/** @file runtime/eventpriv.h
 * Definitions for encoding and decoding events
 */

#include "types.h"
#include "event.h"
#include "codec.h"
#define FCN(f) f##_##event
#include "codecfcn.h"

volatile char* intr;
char arcs;

void
enc (card_t data, unsigned bits)
{
  FCN (enc) (data, bits);
}

card_t
dec (unsigned bits)
{
  return FCN (dec) (bits);
}

void
event_clear (void)
{
  FCN (clear) ();
}

void
event_cleanup (void)
{
  FCN (cleanup) ();
}

void
inflate (void* buf, size_t bytes) {
  FCN (inflate) ((word_t*) buf, bytes);
}

void*
deflate (size_t* size)
{
  FCN (deflate) ();
  *size = NUM_BYTES (ENCVAR (bits));
  return ENCVAR (buf);
}
