/* A Bison parser, made from parser/marde.y
   by GNU bison 1.32.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse deparse
#define yylex delex
#define yyerror deerror
#define yylval delval
#define yychar dechar
#define yydebug dedebug
#define yynerrs denerrs
# define	UNTIL	257
# define	RELEASE	258
# define	IMPL	259
# define	EQUIV	260
# define	OR	261
# define	XOR	262
# define	AND	263
# define	FINALLY	264
# define	GLOBALLY	265
# define	NEXT	266
# define	NE	267
# define	EQ	268
# define	GE	269
# define	LE	270
# define	ROL	271
# define	ROR	272
# define	IS	273
# define	CARDINALITY	274
# define	MIN	275
# define	MAX	276
# define	MAP	277
# define	EQUALS	278
# define	SUBSET	279
# define	MINUS	280
# define	UNION	281
# define	INTERSECT	282
# define	ATOM	283
# define	NUMBER	284
# define	STATE	285
# define	COMP	286
# define	CHARACTER	287
# define	NAME	288
# define	TRUE_	289
# define	FALSE_	290
# define	UNDEFINED	291
# define	FATAL	292
# define	EMPTY	293
# define	PLACE	294
# define	TRANS	295
# define	IN	296
# define	OUT	297
# define	GATE	298
# define	MODEL	299
# define	GRAPH	300
# define	LSTS	301
# define	UNFOLD	302
# define	BREADTH	303
# define	DEPTH	304
# define	STRONG	305
# define	PATH	306
# define	TERMINAL	307
# define	COMPONENTS	308
# define	CD	309
# define	TRANSLATOR	310
# define	COMPILEDIR	311
# define	VISUAL	312
# define	DUMP	313
# define	EVAL	314
# define	HIDE	315
# define	SHOW	316
# define	SUCC	317
# define	PRED	318
# define	GO	319
# define	STATS	320
# define	TIME	321
# define	HELP	322
# define	LOG	323
# define	FUNCTION	324
# define	EXIT	325

#line 3 "parser/marde.y"

#ifdef __WIN32
# undef __STRICT_ANSI__
# include <io.h>
# undef chdir
# define chdir(path) _chdir (path)
#else // WIN32
# include <alloca.h>
#endif // __WIN32
#include <unistd.h> // for chdir(2)
#include <cstdlib> // for getenv(3)

#include "util.h"
#include "StringBuffer.h"
#include "VariableStackMap.h"
#include "Printer.h"

#include "allExpressions.h"
#include "ExpressionSet.h"

#include "Transition.h"
#include "Place.h"
#include "Arc.h"
#include "Net.h"
#include "GlobalMarking.h"
#include "VariableDefinition.h"
#include "VariableSet.h"
#include "Function.h"

#include "Quantifier.h"

#include "typedefs.h"
#include "allTypes.h"
#include "allValues.h"
#include "Valuation.h"

# include <set>
# include <map>
# include <list>
# include <stack>

# ifndef NDEBUG
#  define ASSERT1(x) x
# else
#  define ASSERT1(x)
# endif

  /** @file marde.y
   * Parser for the query language
   */

  /** flag: exiting */
  bool exiting = false;
  /** warning flag (true=print warnings) */
  extern bool dewarnings;
  /** Maximum range size of quantifications */
  extern card_t maxRange;
  /** Translator for property automata */
  extern char* translator;
#ifdef EXPR_COMPILE
  /** name of the compilation directory (NULL=don't compile) */
  extern char* compiledir;
#endif // EXPR_COMPILE

  /** read a command line */
  const char* deline ();
  /** reset the parser and the lexical analyzer */
  void dereset ();
  /** reset the lexical analyzer */
  extern void delexreset ();

  /** lexical analyzer function
   * @return		a terminal symbol, and set yylval to its semantic value
   */
  extern int delex ();

  /** flag: expecting a command keyword */
  bool command = true;
  /** The state being examined */
  static card_t currentState = CARD_T_MAX;
  /** Visualization level */
  static card_t visual;
  /** Flag: hide/reveal */
  static bool hide;

  /** The printer object */
  extern class Printer thePrinter;
  /** The Petri Net */
  extern class Net* net;
  /** Parameters of the function that is currently being processed */
  static class VariableDefinition** currentParameters = NULL;
  /** Arity of the function that is currently being processed */
  static unsigned currentArity = 0;
  /** Function being invoked */
  static std::stack< class Function*, std::list<class Function*> >
    functionStack;
  /** The transition that is currently being processed */
  static class Transition* currentTransition = NULL;
  /** The context transition */
  static class Transition* currentContextTransition = NULL;
  /** The type definition that is currently being processed */
  static const class Type* currentType = NULL;
  /** The context type of currentType (StructType or VectorType or NULL) */
  static const class Type* currentContextType = NULL;
  /** Struct or vector component number currently being parsed */
  static card_t currentComponent;
  /** Type context */
  struct TypeContext
  {
    /** Context type (@see currentContextType), may be NULL */
    const class Type* context;
    /** Component type (@see currentContext) */
    const class Type* component;
    /** Number of current component (@see currentComponent)
     * , meaningless if context==NULL */
    card_t numComponent;
  };
  /** Stack of types, used e.g. when parsing quantifier conditions */
  static std::stack< struct TypeContext, std::list<struct TypeContext> >
    typeStack;
  /** Flag: is an output arc being parsed? */
  static bool isOutputArc = false;

  /** Flag: has an empty list component been parsed? */
  static bool emptyParsed = false;

  typedef std::pair<const class Type*,card_t> StructLevel;
  /** Stack for parsing structs and vectors */
  static std::stack< StructLevel, std::list<StructLevel> > structLevels;

  /** Open a model
   * @param filename	name of the net to be analyzed
   * @param graphfile	base name for the reachability graph files
   * @param regen	flag: regenerate the graph files
   * @return		false on error, true otherwise
   */
  extern bool model (const char* filename, const char* graphfile, bool regen);

  /** Generate an LSTS of the model when generating the state space
   * @param filebase	base file name (NULL=disable LSTS generation)
   */
  extern void lsts (const char* filebase);

  /** Unfold the model
   * @param ffilename	output format and file name (NULL=default,stdout)
   */
  extern void unfold (const char* ffilename);

  /** Dump the syntax tree of the model
   * @param visual	visualization level
   */
  extern void dump (card_t visual);

  /** Perform exhaustive reachability analysis
   * @param state	state to start the analysis with
   * @param breadth	flag: go breadth-first instead of depth-first
   */
  extern void analyze (card_t state, bool breadth);

  /** Check if a state number exists
   * @param state	the state
   * @return		true if the state exists
   */
  extern bool isState (card_t state);

  /** Show a state
   * @param state	the state
   * @param visual	visualization level
   */
  extern void show (card_t state, card_t visual);

  /** Show a path specified as a state list
   * @param sl		the state list
   * @param visual	visualization level
   */
  extern void show (const card_t* states, card_t visual);

  /** Show the successors of a state
   * @param state	the state
   * @param seq		flag: fully expand deterministic sequences
   * @param visual	visualization level
   */
  extern void succ (card_t state, bool seq, card_t visual);

  /** Show the predecessors of a state
   * @param state	the state
   * @param seq		flag: fully expand deterministic sequences
   * @param visual	visualization level
   */
  extern void pred (card_t state, bool seq, card_t visual);

  /** Display statistics */
  extern void stats (void);

  /** Display execution times */
  extern void showtimes (void);

  /** Compute strongly connected components
   * @param state	state in which to start the search
   * @param cond	condition for the states to be included in the search
   */
  extern void strong (card_t state, class Expression* cond);
  /** Display non-trivial terminal strongly connected components */
  extern void terminal ();
  /** Display all strongly connected components
   * @param visual	visualization level
   */
  extern void allcomps (card_t visual);
  /** Show the nodes of a strongly connected component fulfilling a condition
   * @param comp	the component
   * @param cond	the condition
   * @param visual	visualization level
   */
  extern void comp_show (card_t comp,
			 class Expression* cond,
			 card_t visual);
  /** Show the successors of a strongly connected component
   * @param comp	the component
   * @param visual	visualization level
   */
  extern void comp_succ (card_t comp, card_t visual);
  /** Show the predecessors of a strongly connected component
   * @param comp	the component
   * @param visual	visualization level
   */
  extern void comp_pred (card_t comp, card_t visual);
  /** Show the shortest path from a state to a strongly connected component
   * @param state	the state
   * @param comp	the component
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_sc (card_t state, card_t comp,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a strongly connected component to a state
   * @param comp	the component
   * @param state	the state
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_cs (card_t comp, card_t state,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a state to a state
   * @param state	the source state
   * @param dest	the target state
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_ss (card_t state, card_t dest,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a state to a state where a condition holds
   * @param state	the source state
   * @param cond	the condition
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_se (card_t state, class Expression& cond,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a state where a condition holds to a state
   * @param state	the target state
   * @param cond	the condition
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void rpath_se (card_t state, class Expression& cond,
			class Expression* pathc,
			card_t visual);
  /** Show the shortest path from a state to a loop state, plus the loop
   * @param state	the source state
   * @param loop	amount and number of states in the loop
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_sl (card_t state,
		       const card_t* loop,
		       class Expression* pathc,
		       card_t visual);

  /** Evaluate a formula in the current state
   * @param state	state in which to evaluate the formula
   * @param expr	formula to be evaluated
   * @param visual	visualization level for counterexample
   */
  extern void eval (card_t state, class Expression* expr, card_t visual);

  /** Fire an anonymous transition
   * @param trans	the anonymous transition
   * @param state	state in which to fire the transition
   * @param visual	visualization level for counterexample
   */
  extern void fireTransition (class Transition& trans,
			      card_t state,
			      card_t visual);

  /** Display a short help message */
  static void help (void);

  /** Determine whether a model has been loaded
   * @return		true if a model has been loaded
   */
  static bool isNet (void);

  /** Display a type name in an error message
   * @param type	type to be displayed
   */
  static void printType (const class Type& type);

  /** Push the type context on structLevels
   * @param type	new type context
   */
  static void pushTypeContext (const class Type* type);
  /** Restore the type context from structLevels */
  static void popTypeContext ();

  /** Get the parameter of the currently parsed function by name
   * @param name	name of the parameter
   * @return		the corresponding VariableDefinition, or NULL
   */
  static const class VariableDefinition* getParameter (char* name);

  /** Add a parameter to the function definition being parsed
   * @param type	type of the parameter
   * @param name	name of the parameter
   */
  static void addParameter (const class Type* type, char* name);

  /** Get a Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getFunction (const char* name);

  /** Get a zero-arity Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getConstantFunction (const char* name);

  /** Get a Constant by name
   * @param name	the constant name
   * @return		a Constant object
   */
  static const class Constant* getConstant (const char* name);

  /** Get a VariableDefinition by name
   * @param name	the variable name
   * @return		a VariableDefinition object
   */
  static const class VariableDefinition* getVariable (char* name);

  /** Get a state proposition by name
   * @param name	the proposition name
   * @return		the corresponding proposition, or NULL
   */
  static const class Expression* getProposition (char* name);

  /** Resolve a name to a constant or variable
   * @param name	the name
   * @return		the resolved expression, or NULL
   */
  static class Expression* resolveName (char* name);

  /** Ensure that the formula is a set-valued expression
   * @param expr	formula to be checked
   * @param type	expected type of the formula
   * @return		expr, pointer to a Marking object, or NULL
   */
  static class Expression* ensureSet (class Expression* expr,
				      const class Type* type = 0);

  /** Ensure that the formula is a marking expression, converting if needed
   * @param expr	formula to be checked
   * @param type	expected type of the expression
   * @return		pointer to a Marking object, or NULL
   */
  static class Marking* ensureMarking (class Expression* expr,
				       const class Type* type);

  /** Ensure that the formula is not a marking expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* noMarking (class Expression* expr);

  /** Ensure that the formula is a basic expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureExpr (class Expression* expr);

  /** Ensure that the formula is a boolean expression
   * @param expr	formula to be checked
   * @param undefined	flag: allow the formula to be Undefined
   * @return		expr or NULL
   */
  static class Expression* ensureBool (class Expression* expr,
				       bool undefined = false);

  /** Ensure that the formula is a signed integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureInt (class Expression* expr);

  /** Ensure that the formula is an unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureCard (class Expression* expr);

  /** Ensure that the formula is a signed or unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureIntCard (class Expression* expr);

  /** Ensure that the formula is a buffer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureBuffer (class Expression* expr);

  /** Ensure that the formula is a basic expression of ordered type
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureOrdered (class Expression* expr);

  /** Convert an integer to an enumeration value if possible
   * @param type	type of the enumeration value
   * @param value	numerical value to be converted to the enumeration type
   * @return		a constant having the enumeration value or NULL
   */
  static class Expression* enumValue (const class EnumType& type,
				      card_t value);

  /** Ensure that a named component matches a struct being parsed
   * @param name	name of the component
   * @param expr	initialization expression for the component
   * @return		expr or NULL
   */
  static class Expression* namedComponent (char* name, class Expression* expr);

  /** Begin parsing a non-determinism expression
   * @param type	type of the expression
   * @param hidden	flag: hide the variable from transition instances
   * @param name	name of the non-deterministic variable (optional)
   */
  static void beginAny (const class Type*& type, char* name, bool hidden);

  /** End parsing a non-determinisim expression
   * @param type	type of the expression
   * @param name	name of the non-deterministic variable (optional)
   * @param condition	quantification condition (optional)
   * @return		a Variable expression for the variable, or NULL
   */
  static class Variable* endAny (const class Type* type, char* name,
				 class Expression* condition);

  /** Begin parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   */
  static void beginQuantifier (char* name, const class Type* type);

  /** Continue parsing a quantifier expression
   *  (after parsing an optional condition)
   * @param type	type of the quantifier variable
   */
  static void continueQuantifier (ASSERT1 (const class Type* type));

  /** End parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   * @param condition	quantification condition (optional)
   * @param kind	quantification kind (1=sum, 2=forall, 3=exists)
   * @param expr	marking expression
   * @return		expr augmented with the quantifier, or NULL if failed
   */
  static class Expression* endQuantifier (char* name, const class Type* type,
					  class Expression* condition,
					  unsigned kind,
					  class Expression* expr);

  /** Declare a quantified variable
   * @param prefix	prefix of the quantified variable
   * @param quant	name of the quantifier variable
   * @param pred	flag: use a predecessor value of the quantifier
   * @return		a quantified variable, or NULL if failed
   */
  static class Expression* quantifierVariable (char* prefix,
					       char* quant,
					       bool pred);

  /** Try to make expr compatible with type if expr is a Constant
   * @param expr	expression to be made compatible
   * @param type	type to be made compatible with
   * @param casting	flag: typecasting in progress (suppress a warning)
   * @return		true if expr is not a Constant or
   *			if the conversion succeeded
   */
  static bool makeCompatible (class Expression*& expr,
			      const class Type& type,
			      bool casting = false);

  /** Determine whether an expression is compatible with a type
   * @param expr	expression to be checked
   * @param type	the type
   * @return		true if the expression is compatible with the type
   */
  static bool isCompatible (class Expression*& expr,
			    const class Type* type);

  /** Determine whether an expression is compatible with
   * the struct component being parsed
   * @param expr	expression to be checked
   * @param s		the struct whose current component is considered
   * @return		true if the expression is compatible with the struct
   */
  static bool isCompatible (class Expression*& expr,
			    const class StructExpression& s);

  /** Ensure that the type is ordered
   * @param type	type to be checked
   * @return		true if the type is ordered
   */
  static bool isOrdered (const class Type& type);

  /** Check a valuation
   * @param v		valuation to be checked
   * @return		true if the valuation is OK
   */
  static bool check (const class Valuation& v);

  /** Perform constant folding
   * @param expr	expression to be folded
   * @return		expr or a new Constant, or NULL in case of error
   */
  static class Expression* fold (class Expression* expr);

  /** Define a function
   * @param type	type of the function
   * @param name	name of the function
   * @param expr	body of the function
   */
  static void defun (const class Type* type,
		     char* name,
		     class Expression* expr);

  /** Create a RelopExpression or optimize it
   * @param equal	flag: equality comparison (instead of less-than)
   * @param left	left-hand-side of RelopExpression
   * @param right	right-hand-side of RelopExpression
   * @return		RelopExpression or a Boolean constant
   */
  static class Expression* newRelopExpression (bool equal,
					       class Expression* left,
					       class Expression* right);

  /** Create a BinopExpression
   * @param op		operator
   * @param left	left-hand-side of BinopExpression
   * @param right	right-hand-side of BinopExpression
   * @return		BinopExpression
   */
  static class Expression* newBinopExpression (enum BinopExpression::Op op,
					       class Expression* left,
					       class Expression* right);

  /** Create a NotExpression or optimize it
   * @param expr	an expression
   * @return		a negation of the expression
   */
  static class Expression* newNotExpression (class Expression* expr);

  /** Create a BooleanBinop or optimize it
   * @param conj	flag: conjunction (instead of disjunction)
   * @param left	left-hand-side of BooleanBinop
   * @param right	right-hand-side of BooleanBinop
   * @return		left, right, Boolean constant, or a BooleanBinop
   */
  static class Expression* newBooleanBinop (bool conj,
					    class Expression* left,
					    class Expression* right);

  /** Create a SetExpression or optimize it
   * @param op		operator
   * @param left	left-hand-side of SetExpression
   * @param right	right-hand-side of SetExpression
   */
  static class Expression* newSetExpression (enum SetExpression::Op op,
					     class Expression* left,
					     class Expression* right);

  /** Create a CardinalityExpression or optimize it
   * @param op		operator
   * @param expr	the multi-set expression
   */
  static class Expression* newCardinalityExpression
    (enum CardinalityExpression::Op op,
     class Expression* expr);

  /** Create a BufferUnop from a buffer expression
   * @param op		operator
   * @param expr	the buffer expression
   * @return		a BufferUnop object, or NULL
   */
  static class Expression* newBufferUnop (enum BufferUnop::Op op,
					  class Expression* expr);

  /** Variable stack map to be used with variable scoping */
  static class VariableStackMap currentVariables;

  /** Set of subexpressions for common subexpression elimination */
  static class ExpressionSet currentExpressions;

  /** Eliminate common subexpressions
   * @param expr	expression to be searched in currentExpressions
   * @return		expr or an equivalent expression
   */
  inline static class Expression* CSE (class Expression* expr) {
    return expr ? currentExpressions.insert (expr) : NULL;
  }

  /**
   * generic compiler warning reporting function
   * @param s		warning message
   */
  extern void dewarn (const char* s);

  /**
   * generic parser error reporting function
   * @param s		error message
   */
  extern void deerror (const char* s);

#line 644 "parser/marde.y"
#ifndef YYSTYPE
typedef union{
  card_t i;
  card_t* ia;
  bool flag;
  char_t c;
  char* s;
  class Expression* expr;
  class ExpressionList* exprList;
  const class Place* place;
  class Marking* marking;
  const class Type* type;
} yystype;
# define YYSTYPE yystype
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		401
#define	YYFLAG		-32768
#define	YYNTBASE	97

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 325 ? yytranslate[x] : 175)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    31,     2,    30,    17,     2,
      47,    93,    28,    26,    91,    27,    45,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,    90,
      22,    92,    23,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    96,    16,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    94,    15,    95,    33,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    18,    19,    20,
      21,    24,    25,    32,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     3,     5,     6,    10,    12,    16,    19,
      22,    25,    27,    29,    32,    36,    39,    42,    46,    50,
      55,    58,    62,    67,    71,    76,    80,    82,    84,    86,
      88,    91,    93,    95,    98,    99,   104,   105,   111,   113,
     115,   118,   121,   123,   126,   127,   130,   133,   136,   139,
     142,   145,   148,   151,   154,   157,   160,   162,   165,   168,
     172,   176,   178,   181,   184,   186,   187,   190,   191,   194,
     197,   200,   201,   204,   205,   207,   210,   211,   216,   219,
     224,   227,   230,   236,   242,   247,   252,   258,   264,   265,
     269,   271,   273,   275,   276,   278,   279,   281,   283,   285,
     287,   289,   290,   296,   297,   305,   308,   313,   316,   317,
     318,   323,   324,   329,   330,   335,   336,   341,   342,   344,
     348,   351,   354,   355,   361,   365,   367,   371,   372,   373,
     379,   381,   385,   387,   389,   391,   395,   397,   398,   403,
     404,   408,   409,   411,   414,   418,   420,   424,   425,   427,
     429,   431,   433,   435,   437,   439,   442,   443,   449,   451,
     453,   455,   457,   459,   461,   463,   465,   466,   471,   472,
     477,   478,   483,   487,   490,   491,   496,   497,   503,   507,
     511,   515,   519,   523,   527,   531,   535,   539,   543,   547,
     550,   553,   556,   559,   562,   565,   568,   571,   574,   577,
     581,   585,   589,   593,   597,   601,   602,   603,   614,   615,
     623,   627,   628,   634,   637,   641,   645,   649,   653,   657,
     660,   663,   666,   670,   674,   676,   680,   684,   688,   692,
     696,   699,   702,   705,   709,   713,   714,   715,   723,   727,
     731,   732,   740,   741,   749,   750,   760,   761,   762,   765,
     766,   771,   774,   776,   780,   782,   785,   787
};
static const short yyrhs[] =
{
      -1,    98,     0,    90,     0,     0,    90,    99,   100,     0,
     100,     0,    98,    90,   100,     0,    98,    90,     0,    63,
     122,     0,    64,   122,     0,   106,     0,   107,     0,   105,
     108,     0,   105,    78,   108,     0,   105,    78,     0,   105,
      80,     0,   105,    80,   103,     0,   105,    80,    50,     0,
     105,    80,    50,   150,     0,   105,    50,     0,   105,    50,
     150,     0,   105,    81,   111,   109,     0,   105,    81,    50,
       0,   105,    82,   111,   109,     0,   105,    82,    50,     0,
     113,     0,   116,     0,    84,     0,    85,     0,    87,   121,
       0,    86,     0,   117,     0,    88,   125,     0,     0,   105,
      59,   101,   129,     0,     0,   105,    49,    59,   102,   129,
       0,    89,     0,    49,     0,   103,    49,     0,   103,     1,
       0,    49,     0,   104,    49,     0,     0,   105,    76,     0,
      65,   121,     0,    66,   121,     0,   105,    77,     0,    67,
     109,     0,    68,   109,     0,    67,   120,     0,    68,   120,
       0,    73,   121,     0,    74,   121,     0,    75,   121,     0,
      69,     0,    69,   150,     0,    69,    49,     0,    69,    49,
     150,     0,    69,   150,    49,     0,    71,     0,   105,    72,
       0,    49,   152,     0,   152,     0,     0,   109,    49,     0,
       0,   110,    49,     0,   110,    50,     0,   110,   120,     0,
       0,   111,    34,     0,     0,    58,     0,    79,   111,     0,
       0,    79,   111,   114,   115,     0,   112,   120,     0,   115,
      91,   112,   122,     0,    83,   110,     0,   105,    49,     0,
     105,    70,    50,   110,   118,     0,   105,    70,    49,    50,
     118,     0,   105,    70,   104,   118,     0,   105,    70,   150,
     118,     0,   105,    70,   150,    49,   118,     0,   105,    70,
      49,   150,   118,     0,     0,   118,    91,   149,     0,   120,
       0,    52,     0,     1,     0,     0,   120,     0,     0,   120,
       0,    90,     0,    91,     0,    14,     0,    92,     0,     0,
     119,   122,   124,   126,   152,     0,     0,   119,   122,    47,
     128,    93,   127,   152,     0,   119,   122,     0,   128,   123,
     119,   122,     0,   128,   123,     0,     0,     0,   129,    94,
     133,    95,     0,     0,   129,    60,   130,   136,     0,     0,
     129,    61,   131,   136,     0,     0,   129,    62,   132,   140,
       0,     0,   134,     0,   133,   123,   134,     0,   133,   123,
       0,   119,   122,     0,     0,   119,   120,    34,   135,   146,
       0,    94,   137,    95,     0,   138,     0,   137,    90,   138,
       0,     0,     0,   112,   172,     4,   139,   143,     0,   141,
       0,   140,    91,   141,     0,   150,     0,   152,     0,   142,
       0,   143,    91,   142,     0,   152,     0,     0,   144,    91,
     145,   142,     0,     0,    47,   149,    93,     0,     0,   150,
       0,    52,     4,     0,    52,     4,   150,     0,   147,     0,
     148,    91,   147,     0,     0,   150,     0,   152,     0,     1,
       0,     4,     0,     9,     0,    11,     0,     1,     0,   120,
      14,     0,     0,   120,    47,   153,   168,    93,     0,    53,
       0,    54,     0,   173,     0,    52,     0,    48,     0,    51,
       0,    55,     0,    56,     0,     0,    94,   154,   148,    95,
       0,     0,    32,   119,   155,   152,     0,     0,   120,    92,
     156,   152,     0,   152,    32,   122,     0,    44,   152,     0,
       0,   119,    34,   157,   146,     0,     0,   119,   120,    34,
     158,   146,     0,   152,    22,   152,     0,   152,    19,   152,
       0,   152,    23,   152,     0,   152,    20,   152,     0,   152,
      18,   152,     0,   152,    21,   152,     0,   152,    26,   152,
       0,   152,    27,   152,     0,   152,    29,   152,     0,   152,
      28,   152,     0,   152,    30,   152,     0,    33,   152,     0,
      31,   119,     0,    22,   119,     0,    23,   119,     0,    15,
     152,     0,    26,   152,     0,    27,   152,     0,    28,   152,
       0,    29,   152,     0,    30,   152,     0,   152,    24,   152,
       0,   152,    25,   152,     0,   152,    17,   152,     0,   152,
      16,   152,     0,   152,    15,   152,     0,   152,     3,   171,
       0,     0,     0,   152,    45,    94,    46,   159,   149,    96,
     160,   149,    95,     0,     0,   152,    45,    94,   120,   161,
     149,    95,     0,   152,    45,   120,     0,     0,   152,    46,
     162,   150,    96,     0,    34,   152,     0,   152,    11,   152,
       0,   152,     9,   152,     0,   152,     7,   152,     0,   152,
      10,   152,     0,   152,     8,   152,     0,    12,   152,     0,
      13,   152,     0,    14,   152,     0,   152,     5,   152,     0,
     152,     6,   152,     0,    57,     0,   152,    40,   152,     0,
     152,    43,   152,     0,   152,    41,   152,     0,   152,    42,
     152,     0,   152,    39,   152,     0,    35,   152,     0,    36,
     152,     0,    37,   152,     0,    47,   144,    93,     0,   152,
      31,   152,     0,     0,     0,   119,   120,   163,   146,   164,
     151,   152,     0,    45,   120,   121,     0,     4,   120,   121,
       0,     0,    40,   122,    94,   144,    95,   165,   152,     0,
       0,    38,   122,    94,   144,    95,   166,   152,     0,     0,
      38,   122,    31,   122,    94,   144,    95,   167,   152,     0,
       0,     0,   169,   152,     0,     0,   168,    91,   170,   152,
       0,   168,    91,     0,   152,     0,   171,     4,   152,     0,
     122,     0,   174,   172,     0,    58,     0,   174,    58,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   748,   749,   753,   756,   756,   761,   764,   767,   771,
     774,   777,   779,   781,   783,   785,   788,   791,   794,   797,
     800,   803,   806,   809,   812,   815,   818,   820,   822,   825,
     828,   841,   844,   846,   848,   848,   858,   858,   868,   873,
     876,   886,   891,   894,   906,   908,   913,   916,   919,   922,
     925,   928,   936,   944,   950,   953,   964,   967,   970,   973,
     976,   979,   982,   987,   990,   995,   997,  1010,  1012,  1023,
    1026,  1034,  1036,  1041,  1042,  1046,  1053,  1053,  1059,  1073,
    1089,  1092,  1103,  1106,  1109,  1122,  1128,  1131,  1136,  1138,
    1149,  1171,  1174,  1179,  1181,  1186,  1188,  1193,  1193,  1195,
    1197,  1201,  1201,  1206,  1206,  1218,  1226,  1234,  1241,  1245,
    1246,  1248,  1248,  1252,  1252,  1256,  1256,  1263,  1265,  1268,
    1275,  1284,  1301,  1301,  1308,  1312,  1314,  1318,  1319,  1319,
    1338,  1340,  1344,  1369,  1374,  1377,  1387,  1390,  1390,  1403,
    1405,  1410,  1412,  1415,  1418,  1423,  1488,  1574,  1576,  1581,
    1586,  1589,  1592,  1595,  1600,  1603,  1622,  1622,  1650,  1656,
    1662,  1665,  1668,  1674,  1680,  1683,  1686,  1686,  1816,  1816,
    1833,  1833,  1893,  1927,  1930,  1930,  1935,  1935,  1940,  1943,
    1946,  1949,  1952,  1955,  1958,  1982,  2001,  2004,  2007,  2010,
    2016,  2034,  2042,  2050,  2056,  2062,  2081,  2084,  2087,  2090,
    2093,  2096,  2099,  2102,  2105,  2134,  2134,  2134,  2171,  2171,
    2214,  2261,  2261,  2316,  2319,  2329,  2339,  2349,  2355,  2358,
    2366,  2374,  2382,  2393,  2404,  2407,  2410,  2413,  2416,  2419,
    2422,  2425,  2428,  2431,  2434,  2488,  2488,  2488,  2495,  2498,
    2501,  2501,  2549,  2549,  2584,  2584,  2637,  2655,  2655,  2687,
    2687,  2724,  2730,  2739,  2758,  2774,  2779,  2781
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "'?'", "':'", "UNTIL", "RELEASE", "IMPL", 
  "EQUIV", "OR", "XOR", "AND", "FINALLY", "GLOBALLY", "NEXT", "'|'", 
  "'^'", "'&'", "NE", "EQ", "GE", "LE", "'<'", "'>'", "ROL", "ROR", "'+'", 
  "'-'", "'*'", "'/'", "'%'", "'#'", "IS", "'~'", "'!'", "CARDINALITY", 
  "MIN", "MAX", "MAP", "EQUALS", "SUBSET", "MINUS", "UNION", "INTERSECT", 
  "ATOM", "'.'", "'['", "'('", "NUMBER", "STATE", "COMP", "CHARACTER", 
  "NAME", "TRUE_", "FALSE_", "UNDEFINED", "FATAL", "EMPTY", "PLACE", 
  "TRANS", "IN", "OUT", "GATE", "MODEL", "GRAPH", "LSTS", "UNFOLD", 
  "BREADTH", "DEPTH", "STRONG", "PATH", "TERMINAL", "COMPONENTS", "CD", 
  "TRANSLATOR", "COMPILEDIR", "VISUAL", "DUMP", "EVAL", "HIDE", "SHOW", 
  "SUCC", "PRED", "GO", "STATS", "TIME", "HELP", "LOG", "FUNCTION", 
  "EXIT", "';'", "','", "'='", "')'", "'{'", "'}'", "']'", "script", 
  "statements", "@1", "statement", "@2", "@3", "statelist", "statelist_", 
  "_opt_visual", "analyze", "strong", "eval", "state_", "state", 
  "_opt_exclam", "_opt_place", "hide", "@4", "hide_list", "go", "path", 
  "path_expr", "typereference", "name_", "_opt_name", "name", "delim", 
  "next_eq", "function", "@5", "@6", "param_list", "trans", "@7", "@8", 
  "@9", "_list_var_expr", "var_expr", "@10", "trans_places", 
  "_list_place_marking", "place_marking", "@11", "gate_list", "gate", 
  "marking", "marking_list", "marking_list_", "@12", "_opt_expr", 
  "_opt__expr", "struct_expr", "expr_", "expr", "quantifier", "formula", 
  "@13", "@14", "@15", "@16", "@17", "@18", "@19", "@20", "@21", "@22", 
  "@23", "@24", "@25", "@26", "@27", "arg_list", "@28", "@29", 
  "colon_formula", "placename_", "placename", "_nopt_place", NULL
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    97,    97,    98,    99,    98,    98,    98,    98,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   101,   100,   102,   100,   100,   103,
     103,   103,   104,   104,   105,   105,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   107,   107,   107,   107,
     107,   107,   107,   108,   108,   109,   109,   110,   110,   110,
     110,   111,   111,   112,   112,   113,   114,   113,   115,   115,
     116,   116,   117,   117,   117,   117,   117,   117,   118,   118,
     119,   120,   120,   121,   121,   122,   122,   123,   123,   124,
     124,   126,   125,   127,   125,   128,   128,   128,   128,   129,
     129,   130,   129,   131,   129,   132,   129,   133,   133,   133,
     133,   134,   135,   134,   136,   137,   137,   138,   139,   138,
     140,   140,   141,   142,   143,   143,   144,   145,   144,   146,
     146,   147,   147,   147,   147,   148,   148,   149,   149,   150,
     151,   151,   151,   151,   152,   152,   153,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   154,   152,   155,   152,
     156,   152,   152,   152,   157,   152,   158,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   159,   160,   152,   161,   152,
     152,   162,   152,   152,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   163,   164,   152,   152,   152,
     165,   152,   166,   152,   167,   152,   168,   169,   168,   170,
     168,   168,   171,   171,   172,   173,   174,   174
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     1,     1,     0,     3,     1,     3,     2,     2,
       2,     1,     1,     2,     3,     2,     2,     3,     3,     4,
       2,     3,     4,     3,     4,     3,     1,     1,     1,     1,
       2,     1,     1,     2,     0,     4,     0,     5,     1,     1,
       2,     2,     1,     2,     0,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     3,
       3,     1,     2,     2,     1,     0,     2,     0,     2,     2,
       2,     0,     2,     0,     1,     2,     0,     4,     2,     4,
       2,     2,     5,     5,     4,     4,     5,     5,     0,     3,
       1,     1,     1,     0,     1,     0,     1,     1,     1,     1,
       1,     0,     5,     0,     7,     2,     4,     2,     0,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     1,     3,
       2,     2,     0,     5,     3,     1,     3,     0,     0,     5,
       1,     3,     1,     1,     1,     3,     1,     0,     4,     0,
       3,     0,     1,     2,     3,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     2,     0,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     4,     0,     4,
       0,     4,     3,     2,     0,     4,     0,     5,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     0,     0,    10,     0,     7,
       3,     0,     5,     2,     3,     3,     3,     3,     3,     2,
       2,     2,     3,     3,     1,     3,     3,     3,     3,     3,
       2,     2,     2,     3,     3,     0,     0,     7,     3,     3,
       0,     7,     0,     7,     0,     9,     0,     0,     2,     0,
       4,     2,     1,     3,     1,     2,     1,     2
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
      44,     0,     0,     0,     0,     0,     0,     0,    61,     0,
       0,     0,    71,    67,    28,    29,    31,     0,     0,    38,
       4,     2,     6,     0,    11,    12,    26,    27,    32,    92,
      91,    96,     9,    10,    94,    46,    47,    49,    51,    50,
      52,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   162,     0,   163,   161,
     158,   159,   164,   165,   224,   256,   166,     0,    90,    57,
     149,   160,     0,    53,    54,    55,    76,     0,    30,     0,
      90,    33,    44,    44,     0,     0,    34,     0,    62,    45,
      48,     0,    16,    71,    71,    13,    64,    66,     0,   219,
     220,   221,   193,   191,   192,   194,   195,   196,   197,   198,
     190,   168,   189,   213,   230,   231,   232,     0,     0,   173,
       0,     0,   136,    59,     0,   174,   235,   155,   156,   170,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   257,   254,   255,    72,    73,    68,
      69,    70,     0,     5,     7,    36,    63,    21,   109,     0,
      67,    88,    88,     0,    14,    39,     0,     0,    23,    65,
      25,    65,   239,     0,     0,     0,     0,   238,   137,   233,
     161,   145,     0,   142,   139,   176,   139,   247,     0,   252,
     204,   222,   223,   216,   218,   215,   217,   214,   203,   202,
     201,   182,   179,   181,   183,   178,   180,   199,   200,   184,
     185,   187,   186,   188,   234,   172,   229,   225,   227,   228,
     226,     0,   210,     0,    74,     0,    77,    99,     0,   100,
     101,   109,    35,    88,    88,     0,    43,    84,    88,    85,
      19,    41,    40,    22,    24,   169,     0,     0,     0,     0,
       0,     0,   167,     0,   175,   139,   236,     0,     0,   171,
       0,   205,   208,     0,    78,    73,     0,     0,     0,    37,
     111,   113,   115,     0,    83,    87,    82,     0,    86,     0,
     242,   240,   138,   133,   144,   146,     0,   148,   177,     0,
     249,   157,   248,   253,     0,     0,   212,     0,   105,    97,
      98,   103,     0,   102,     0,     0,     0,     0,     0,   118,
      89,     0,     0,     0,   140,   150,   151,   152,   153,     0,
       0,     0,     0,    79,     0,     0,    73,   112,   114,   116,
     130,   132,    96,   121,   110,     0,   244,   243,   241,   237,
     250,   206,   209,   104,   106,     0,     0,   125,     0,   122,
     119,     0,     0,     0,    73,   124,   131,   139,   245,     0,
     128,   126,   123,   207,     0,   134,   129,     0,   135,     0,
       0,     0
};

static const short yydefgoto[] =
{
     399,    21,    92,    22,   188,   261,   197,   191,    23,    24,
      25,   105,    37,    87,    86,   375,    26,   178,   256,    27,
      28,   267,    77,    78,    35,   175,   332,   260,    91,   298,
     354,   297,   262,   334,   335,   336,   338,   339,   387,   357,
     376,   377,   394,   359,   360,   312,   396,   131,   279,   284,
     211,   212,   316,   317,   349,    80,   217,   134,   203,   218,
     214,   285,   324,   382,   325,   253,   216,   319,   343,   342,
     381,   287,   288,   350,   220,   176,    81,    82
};

static const short yypact[] =
{
     352,    13,    13,   164,   164,   233,   233,   936,-32768,   164,
     164,   164,-32768,-32768,-32768,-32768,-32768,   164,   156,-32768,
      25,   -78,-32768,  1630,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,    -8,-32768,    -8,
  -32768,   236,   156,  1851,  1851,  1851,  1851,   156,   156,  1851,
    1851,  1851,  1851,  1851,   156,   156,  1851,  1851,  1851,  1851,
    1851,    16,     8,  1851,   156,  1851,-32768,  1213,-32768,   250,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,    45,    -4,    18,
    1941,-32768,   512,-32768,-32768,-32768,    19,   243,-32768,   259,
  -32768,-32768,   404,  1847,  1005,  1282,-32768,  1713,-32768,-32768,
  -32768,  1074,    64,     7,   112,-32768,  1941,-32768,   609,  2121,
    2121,  2121,   295,-32768,-32768,   295,   295,   295,   295,   295,
  -32768,-32768,   295,   295,   295,   295,   295,   153,   -21,   129,
     609,   -19,  1941,-32768,  1351,-32768,   152,-32768,-32768,-32768,
  -32768,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,   706,  1851,  1851,  1851,
    1851,  1851,    23,-32768,-32768,-32768,-32768,-32768,   136,-32768,
  -32768,-32768,     1,-32768,-32768,-32768,  1941,-32768,-32768,   866,
  -32768,   151,   174,  1851,-32768,-32768,  1421,   176,-32768,   195,
  -32768,   195,-32768,  1851,     8,  1851,  1851,-32768,-32768,-32768,
     188,-32768,    90,-32768,   202,-32768,   202,     5,  1851,  1941,
     267,  1981,  1981,  2019,  2019,  2056,  2089,  2121,  2152,  2182,
    2211,   555,   555,   337,   337,   337,   337,   636,   636,   418,
     418,   353,   353,   353,   353,-32768,   454,   360,   264,   264,
     129,   172,-32768,  1851,-32768,   156,   183,-32768,   155,-32768,
  -32768,-32768,    22,-32768,-32768,   178,-32768,   190,-32768,   190,
  -32768,-32768,-32768,    -8,    -8,   129,   169,   124,   126,  1851,
    1490,  1351,-32768,  1782,-32768,   202,-32768,   203,  1851,  1981,
    1851,-32768,-32768,   218,-32768,   136,   162,    -1,  1851,    22,
  -32768,-32768,-32768,     4,   190,   190,   190,  1143,   190,  1851,
  -32768,-32768,-32768,  1941,-32768,-32768,   198,-32768,-32768,    76,
     208,-32768,  1941,  1941,   791,  1560,-32768,   187,-32768,-32768,
  -32768,-32768,   168,  1941,   228,   228,  1851,    10,   -36,-32768,
  -32768,   181,  1851,  1851,-32768,-32768,-32768,-32768,-32768,  1851,
    1851,   234,   237,-32768,  1851,   162,    -9,-32768,-32768,   252,
  -32768,-32768,   310,-32768,-32768,    17,-32768,   295,   295,  1941,
    1941,-32768,-32768,  1941,-32768,   189,   -29,-32768,  1851,-32768,
  -32768,  1851,  1560,   342,    -9,-32768,-32768,   202,   295,   253,
  -32768,-32768,-32768,-32768,  1851,-32768,   256,  1851,-32768,   350,
     354,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,   220,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   254,     0,   166,   221,  -134,-32768,-32768,-32768,-32768,
  -32768,    40,   -16,   149,    41,     2,    21,-32768,-32768,-32768,
  -32768,-32768,    99,-32768,-32768,-32768,-32768,    24,-32768,    35,
  -32768,   -12,-32768,-32768,    -5,  -185,-32768,  -198,-32768,  -215,
     100,-32768,    -7,     9,-32768,   -23,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,    11,-32768,-32768
};


#define	YYLAST		2257


static const short yytable[] =
{
     106,   286,    89,    32,    33,    29,    39,   277,   278,    29,
     137,    29,    93,   -95,    29,   257,    79,    29,    29,   -75,
     109,   110,   111,   112,    29,    -3,   115,   116,   117,   118,
     119,   113,   114,   122,   123,   124,   125,   126,   120,   121,
     129,   107,   132,   138,   255,    36,    29,   -95,   258,   254,
      83,    84,    85,   177,   329,   330,    30,   198,    88,   364,
      30,   384,    30,   127,   128,    30,   385,   140,    30,    30,
     318,   186,   208,   206,   209,    30,   133,   345,   106,   135,
     346,  -127,   300,   301,   302,   347,  -127,   348,   139,   329,
     330,   182,   331,   259,  -117,  -117,  -246,    30,  -246,  -117,
     -95,   -95,   -95,   -95,   187,   -95,   192,  -120,  -120,   -75,
     -95,   341,  -120,   195,   196,    -3,   303,   251,   219,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   213,   246,   247,   248,   249,   250,   202,
      31,    31,    34,    34,    38,    40,    29,    29,    34,    34,
      34,   327,   200,    29,   -93,    29,    34,    90,   245,    29,
     186,   207,   392,    29,   172,   173,   -17,   271,   -88,    29,
     275,   281,   132,   132,   204,   282,   215,   -95,    29,   -91,
      29,   108,   280,   -95,   254,   289,    90,    90,   264,   273,
     266,   274,   -91,    90,    90,   270,   276,    30,    30,   395,
      31,    31,   398,   130,    30,   208,    30,   208,   291,   310,
      30,   311,   -91,   268,    30,   272,   136,   179,   180,   177,
      30,    31,   269,   -65,    29,   -91,   181,   -92,    31,    30,
     -91,    30,   296,   -80,    29,  -108,  -108,   205,  -108,   283,
     -92,   -91,   -95,   -95,   -93,   -95,   313,    34,  -107,  -107,
      29,  -107,   293,   309,   -91,   322,   -17,   323,   -88,   -88,
     -92,   290,   208,   -95,   295,   333,   366,   -95,   -95,    34,
     -91,   307,   -65,   -92,   -91,    30,   132,   337,   -92,   314,
     213,   344,   179,   180,   320,    30,   321,   -91,   328,  -251,
     340,  -251,   -91,   304,   305,   306,   -95,   171,   308,   172,
     173,    30,   183,   184,   326,    31,   355,   351,   352,   367,
     368,   252,   356,   -65,   199,   201,   369,   370,   -92,   353,
     371,   373,   372,   -80,   167,   168,   169,   170,   171,   363,
     172,   173,   -91,   378,   379,   361,   390,   397,   393,   337,
     400,   -95,    -1,    31,   401,   194,   265,   374,   388,   365,
     299,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     358,   313,   391,   386,   313,   389,   167,   168,   169,   170,
     171,   315,   172,   173,   165,   166,   383,   361,     0,   380,
       0,     0,   167,   168,   169,   170,   171,     0,   172,   173,
     292,   169,   170,   171,   294,   172,   173,    90,     0,     0,
       0,     0,     0,     0,   181,     1,     2,     3,     4,     5,
       6,     7,     0,     8,     0,     9,    10,    11,     0,     0,
       0,    12,     0,     0,     0,    13,    14,    15,    16,    17,
      18,    19,    20,     0,     0,    31,   162,   163,   164,   165,
     166,     0,    90,     0,     0,     0,     0,   167,   168,   169,
     170,   171,     0,   172,   173,     0,     0,     1,     2,     3,
       4,     5,     6,     7,     0,     8,    31,     9,    10,    11,
       0,    90,     0,    12,     0,     0,   362,    13,    14,    15,
      16,    17,    18,    19,   168,   169,   170,   171,     0,   172,
     173,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,   -95,    29,    90,   -95,   -95,   -95,   -95,   -95,
     -95,   -95,   -95,   -95,    31,     0,     0,   -95,   -95,   -95,
     -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,
     -95,   -95,   -95,   -95,   -95,     0,     0,     0,     0,     0,
       0,   -95,   -95,   -95,   -95,   -95,     0,   -95,   -95,     0,
       0,   -95,     0,     0,    30,     0,     0,     0,     0,     0,
     174,     0,   -95,   -95,   -95,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,     0,     0,
       0,     0,     0,     0,   167,   168,   169,   170,   171,     0,
     172,   173,   -95,   -95,     0,   -95,   -95,   -95,   -95,   -93,
      29,     0,   -93,   -93,   -93,   -93,   -93,   -93,   -93,   -93,
     -93,     0,     0,     0,   -93,   -93,   -93,   -93,   -93,   -93,
     -93,   -93,   -93,   -93,   -93,   -93,   -93,   -93,   -93,   -93,
     -93,   -93,     0,     0,     0,     0,     0,     0,   -93,   -93,
     -93,   -93,   -93,     0,   -93,   -93,     0,     0,   -93,     0,
       0,    30,   160,   161,   162,   163,   164,   165,   166,   -93,
     -93,   -93,     0,     0,     0,   167,   168,   169,   170,   171,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   -93,
     -93,     0,   -93,   -93,   -93,   -93,   -95,    29,     0,   -95,
     -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,     0,     0,
       0,   -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,
     -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,   -95,     0,
       0,     0,     0,     0,     0,   -95,   -95,   -95,   -95,   -95,
       0,   -95,   -95,     0,     0,   -95,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,   -95,   -95,   -95,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    41,     0,     0,    42,   -95,   -95,     0,   -95,
     -95,   -95,   -95,    43,    44,    45,    46,     0,     0,     0,
       0,     0,     0,    47,    48,     0,     0,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
       0,    62,     0,     0,     0,    63,    64,     0,    65,    66,
       0,     0,    68,    69,    70,    71,    72,    73,    74,    75,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -42,    41,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,    43,    44,
      45,    46,     0,     0,     0,    76,     0,  -147,    47,    48,
       0,     0,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,     0,    62,     0,     0,     0,
      63,    64,     0,    65,    66,   -42,   263,    68,    69,    70,
      71,    72,    73,    74,    75,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -56,    41,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,    43,    44,
      45,    46,     0,     0,     0,     0,   -42,   -42,    47,    48,
      76,     0,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,     0,    62,     0,     0,     0,
      63,    64,     0,    65,    66,    67,     0,    68,    69,    70,
      71,    72,    73,    74,    75,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   -81,    41,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,    43,    44,    45,
      46,     0,     0,     0,     0,     0,   -56,    47,    48,     0,
      76,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,     0,    62,     0,     0,     0,    63,
      64,     0,    65,    66,     0,     0,    68,    69,    70,    71,
      72,    73,    74,    75,   185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   -15,    41,     0,     0,    42,     0,
       0,     0,     0,     0,     0,     0,    43,    44,    45,    46,
       0,     0,     0,     0,     0,   -81,    47,    48,     0,    76,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,     0,    62,     0,     0,     0,    63,    64,
       0,    65,    66,   193,     0,    68,    69,    70,    71,    72,
      73,    74,    75,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -147,    41,     0,     0,    42,     0,     0,
       0,     0,     0,     0,     0,    43,    44,    45,    46,     0,
       0,     0,     0,     0,   -15,    47,    48,     0,    76,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,     0,    62,     0,     0,     0,    63,    64,     0,
      65,    66,     0,     0,    68,    69,    70,    71,    72,    73,
      74,    75,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   -58,    41,     0,     0,    42,     0,     0,
       0,     0,     0,     0,     0,    43,    44,    45,    46,     0,
       0,     0,     0,  -147,  -147,    47,    48,    76,     0,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,     0,    62,     0,     0,     0,    63,    64,     0,
      65,    66,     0,     0,    68,    69,    70,    71,    72,    73,
      74,    75,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   -20,    41,     0,     0,    42,     0,     0,     0,
       0,     0,     0,     0,    43,    44,    45,    46,     0,     0,
       0,     0,     0,   -58,    47,    48,     0,    76,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,     0,    62,     0,     0,     0,    63,    64,     0,    65,
      66,     0,     0,    68,    69,    70,    71,    72,    73,    74,
      75,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    41,     0,     0,    42,     0,     0,     0,     0,
       0,     0,     0,    43,    44,    45,    46,     0,     0,     0,
       0,     0,   -20,    47,    48,     0,    76,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
       0,    62,     0,     0,     0,    63,    64,     0,    65,    66,
       0,     0,    68,   210,    70,    71,    72,    73,    74,    75,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   -18,    41,     0,     0,    42,     0,     0,     0,     0,
       0,     0,     0,    43,    44,    45,    46,     0,     0,     0,
       0,     0,  -141,    47,    48,    76,  -141,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
       0,    62,     0,     0,     0,    63,    64,     0,    65,    66,
       0,     0,    68,    69,    70,    71,    72,    73,    74,    75,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,    42,     0,     0,     0,     0,     0,
       0,     0,    43,    44,    45,    46,     0,     0,     0,     0,
       0,   -18,    47,    48,     0,    76,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,     0,
      62,     0,     0,     0,    63,    64,     0,    65,    66,     0,
       0,    68,    69,    70,    71,    72,    73,    74,    75,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,    42,     0,     0,     0,     0,     0,
       0,     0,    43,    44,    45,    46,     0,     0,     0,     0,
       0,  -143,    47,    48,    76,  -143,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,     0,
      62,     0,     0,     0,    63,    64,     0,    65,    66,     0,
       0,    68,    69,    70,    71,    72,    73,    74,    75,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,    42,     0,     0,     0,     0,     0,
       0,     0,    43,    44,    45,    46,     0,     0,     0,     0,
       0,     0,    47,    48,    76,  -147,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,     0,
      62,     0,     0,     0,    63,    64,     0,    65,    66,    94,
      95,    68,    69,    70,    71,    72,    73,    74,    75,    96,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      97,     0,    98,     0,     0,     0,    99,   100,   101,     0,
     102,   103,   104,     0,    41,     0,     0,    42,     0,     0,
       0,     0,     0,     0,    76,    43,    44,    45,    46,     0,
       0,     0,     0,     0,     0,    47,    48,     0,     0,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,     0,    62,     0,     0,     0,    63,    64,     0,
      65,    66,   189,   190,    68,    69,    70,    71,    72,    73,
      74,    75,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,    42,     0,     0,     0,
       0,     0,     0,     0,    43,    44,    45,    46,     0,     0,
       0,     0,     0,     0,    47,    48,     0,    76,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,     0,    62,     0,     0,     0,    63,    64,     0,    65,
      66,     0,     0,    68,    69,    70,    71,    72,    73,    74,
      75,     0,     0,     0,     0,     0,     0,    -8,     0,     0,
       0,     0,    41,     0,     0,    42,     0,     0,     0,     0,
       0,     0,     0,    43,    44,    45,    46,     0,     0,     0,
       0,     0,     0,    47,    48,  -147,    76,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
       0,    62,     0,     0,     0,    63,    64,     0,    65,    66,
       0,     0,    68,    69,    70,    71,    72,    73,    74,    75,
       1,     2,     3,     4,     5,     6,     7,     0,     8,     0,
       9,    10,    11,     0,     0,     0,    12,     0,     0,     0,
      13,    14,    15,    16,    17,    18,    19,    -8,     0,     0,
       0,     0,     0,     0,   141,    76,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,     0,     0,     0,     0,     0,     0,
     167,   168,   169,   170,   171,     0,   172,   173,   144,   145,
     146,   147,   148,     0,     0,     0,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,     0,     0,     0,     0,     0,     0,
     167,   168,   169,   170,   171,     0,   172,   173,   146,   147,
     148,     0,     0,     0,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,     0,     0,     0,     0,     0,     0,   167,   168,
     169,   170,   171,     0,   172,   173,   147,   148,     0,     0,
       0,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,     0,
       0,     0,     0,     0,     0,   167,   168,   169,   170,   171,
     148,   172,   173,     0,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,     0,     0,     0,     0,     0,     0,   167,   168,
     169,   170,   171,     0,   172,   173,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,     0,     0,     0,     0,     0,     0,
     167,   168,   169,   170,   171,     0,   172,   173,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,     0,     0,     0,     0,     0,
       0,   167,   168,   169,   170,   171,     0,   172,   173,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,     0,     0,     0,     0,     0,
       0,   167,   168,   169,   170,   171,     0,   172,   173,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,     0,     0,     0,     0,     0,     0,
     167,   168,   169,   170,   171,     0,   172,   173
};

static const short yycheck[] =
{
      23,   216,    18,     1,     2,     1,     6,   205,   206,     1,
      14,     1,    90,     0,     1,    14,     7,     1,     1,     0,
      43,    44,    45,    46,     1,     0,    49,    50,    51,    52,
      53,    47,    48,    56,    57,    58,    59,    60,    54,    55,
      63,    49,    65,    47,   178,     4,     1,    31,    47,    58,
       9,    10,    11,    34,    90,    91,    52,    50,    17,    95,
      52,    90,    52,    61,    62,    52,    95,    49,    52,    52,
     285,    94,    91,    94,    93,    52,    67,     1,   101,    34,
       4,    90,    60,    61,    62,     9,    95,    11,    92,    90,
      91,    89,    93,    92,    90,    91,    91,    52,    93,    95,
      90,    91,    94,    90,    95,    95,    97,    90,    91,    90,
      94,   309,    95,    49,    50,    90,    94,    94,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   134,   167,   168,   169,   170,   171,   108,
       1,     2,     3,     4,     5,     6,     1,     1,     9,    10,
      11,   295,    50,     1,     0,     1,    17,    18,   166,     1,
     193,   130,   387,     1,    45,    46,     0,     1,     0,     1,
     203,    91,   205,   206,    31,    95,    34,     0,     1,     1,
       1,    42,     4,     4,    58,   218,    47,    48,   189,   199,
      49,   201,    14,    54,    55,   196,   204,    52,    52,   394,
      61,    62,   397,    64,    52,    91,    52,    91,    46,    95,
      52,    95,    34,    49,    52,    49,    77,    49,    50,    34,
      52,    82,   192,     0,     1,    47,    87,     1,    89,    52,
      52,    52,   258,     0,     1,    90,    91,    94,    93,    47,
      14,     1,    90,    91,    90,    93,   279,   108,    90,    91,
       1,    93,   253,    94,    14,   288,    90,   290,    90,    91,
      34,     4,    91,    14,    91,   298,    95,    90,    91,   130,
      92,    91,    49,    47,    34,    52,   309,   303,    52,   280,
     281,    93,    49,    50,    91,    52,    93,    47,   296,    91,
     307,    93,    52,   263,   264,   265,    47,    43,   268,    45,
      46,    52,    92,    93,    96,   166,   332,   324,   325,   342,
     343,   172,    94,    90,   103,   104,   349,   350,    92,   327,
      96,   354,    95,    90,    39,    40,    41,    42,    43,   337,
      45,    46,    92,    91,    34,   336,     4,    91,    95,   365,
       0,    92,     0,   204,     0,   101,   190,   355,   381,   338,
     261,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     335,   394,   384,   378,   397,   382,    39,    40,    41,    42,
      43,   281,    45,    46,    31,    32,   375,   378,    -1,   365,
      -1,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
     251,    41,    42,    43,   255,    45,    46,   258,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    -1,    -1,
      -1,    79,    -1,    -1,    -1,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    -1,   296,    28,    29,    30,    31,
      32,    -1,   303,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,   327,    73,    74,    75,
      -1,   332,    -1,    79,    -1,    -1,   337,    83,    84,    85,
      86,    87,    88,    89,    40,    41,    42,    43,    -1,    45,
      46,    -1,    -1,    -1,   355,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     0,     1,   365,     3,     4,     5,     6,     7,
       8,     9,    10,    11,   375,    -1,    -1,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      -1,    49,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    60,    61,    62,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    90,    91,    -1,    93,    94,    95,    96,     0,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    -1,    49,    -1,
      -1,    52,    26,    27,    28,    29,    30,    31,    32,    60,
      61,    62,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    -1,    93,    94,    95,    96,     0,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    -1,    -1,
      -1,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    -1,    49,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,     4,    90,    91,    -1,    93,
      94,    95,    96,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    94,    -1,    96,    22,    23,
      -1,    -1,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    90,    91,    22,    23,
      94,    -1,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    47,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    90,    22,    23,    -1,
      94,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,    44,
      45,    -1,    47,    48,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     0,     1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    90,    22,    23,    -1,    94,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,
      -1,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,     1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    90,    22,    23,    -1,    94,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,     1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    90,    91,    22,    23,    94,    -1,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     0,     1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    90,    22,    23,    -1,    94,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    -1,    -1,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    90,    22,    23,    -1,    94,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    91,    22,    23,    94,    95,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    90,    22,    23,    -1,    94,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    -1,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    91,    22,    23,    94,    95,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    -1,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    94,    95,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    72,    -1,    -1,    -1,    76,    77,    78,    -1,
      80,    81,    82,    -1,     1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    94,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    -1,    -1,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    -1,    -1,    -1,    -1,    -1,     0,    -1,    -1,
      -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    93,    94,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,    -1,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    94,     5,     6,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,     9,    10,
      11,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    10,    11,    -1,    -1,
      -1,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      11,    45,    46,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#ifdef __cplusplus
# define YYSTD(x) std::x
#else
# define YYSTD(x) x
#endif

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
#  define YYSIZE_T YYSTD (size_t)
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#    define YYSIZE_T YYSTD (size_t)
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  ifdef __cplusplus
#   include <cstdlib> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T std::size_t
#  else
#   ifdef __STDC__
#    include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#    define YYSIZE_T size_t
#   endif
#  endif
#  define YYSTACK_ALLOC YYSTD (malloc)
#  define YYSTACK_FREE YYSTD (free)
# endif

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Relocate the TYPE STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Type, Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	yymemcpy ((char *) yyptr, (char *) (Stack),			\
		  yysize * (YYSIZE_T) sizeof (Type));			\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (Type) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# ifdef __cplusplus
#  include <cstddef> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T std::size_t
# else
#  ifdef __STDC__
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  ifdef __cplusplus
#   include <cstdio>  /* INFRINGES ON USER NAME SPACE */
#  else
#   include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYFPRINTF YYSTD (fprintf)
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace. [The following comment makes no
   sense to me.  Could someone clarify it?  --akim] Since this is
   uninitialized, it does not stop multiple parsers from coexisting.
   */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#if ! defined (yyoverflow) && ! defined (yymemcpy)
# if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#  define yymemcpy __builtin_memcpy
# else				/* not GNU C or C++ */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
#  if defined (__STDC__) || defined (__cplusplus)
yymemcpy (char *yyto, const char *yyfrom, YYSIZE_T yycount)
#  else
yymemcpy (yyto, yyfrom, yycount)
     char *yyto;
     const char *yyfrom;
     YYSIZE_T yycount;
#  endif
{
  register const char *yyf = yyfrom;
  register char *yyt = yyto;
  register YYSIZE_T yyi = yycount;

  while (yyi-- != 0)
    *yyt++ = *yyf++;
}
# endif
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 341 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# ifdef __cplusplus
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else /* !__cplusplus */
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif /* !__cplusplus */
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (short, yyss);
	YYSTACK_RELOCATE (YYSTYPE, yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (YYLTYPE, yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 755 "parser/marde.y"
{ command = true; dewarn ("extraneous semicolon"); ;
    break;}
case 4:
#line 758 "parser/marde.y"
{ command = true; dewarn ("extraneous semicolon"); ;
    break;}
case 5:
#line 760 "parser/marde.y"
{ command = true; ;
    break;}
case 6:
#line 763 "parser/marde.y"
{ command = true; ;
    break;}
case 7:
#line 766 "parser/marde.y"
{ command = true; ;
    break;}
case 9:
#line 773 "parser/marde.y"
{ if (yyvsp[0].s) currentState = model (yyvsp[0].s, 0, true) ? 0 : CARD_T_MAX; ;
    break;}
case 10:
#line 776 "parser/marde.y"
{ if (yyvsp[0].s) currentState = model (0, yyvsp[0].s, false) ? 0 : CARD_T_MAX; ;
    break;}
case 15:
#line 787 "parser/marde.y"
{ eval (currentState, resolveName (newString ("eval")), visual); ;
    break;}
case 16:
#line 790 "parser/marde.y"
{ show (currentState, visual); ;
    break;}
case 17:
#line 793 "parser/marde.y"
{ if (yyvsp[0].ia) { show (yyvsp[0].ia, visual); delete[] yyvsp[0].ia; } ;
    break;}
case 18:
#line 796 "parser/marde.y"
{ comp_show (yyvsp[0].i, 0, visual); ;
    break;}
case 19:
#line 799 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) comp_show (yyvsp[-1].i, yyvsp[0].expr, visual); ;
    break;}
case 20:
#line 802 "parser/marde.y"
{ comp_show (yyvsp[0].i, 0, visual); ;
    break;}
case 21:
#line 805 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) comp_show (yyvsp[-1].i, yyvsp[0].expr, visual); ;
    break;}
case 22:
#line 808 "parser/marde.y"
{ succ (yyvsp[0].i, yyvsp[-1].flag, visual); ;
    break;}
case 23:
#line 811 "parser/marde.y"
{ comp_succ (yyvsp[0].i, visual); ;
    break;}
case 24:
#line 814 "parser/marde.y"
{ pred (yyvsp[0].i, yyvsp[-1].flag, visual); ;
    break;}
case 25:
#line 817 "parser/marde.y"
{ comp_pred (yyvsp[0].i, visual); ;
    break;}
case 28:
#line 824 "parser/marde.y"
{ stats (); ;
    break;}
case 29:
#line 827 "parser/marde.y"
{ showtimes (); ;
    break;}
case 30:
#line 830 "parser/marde.y"
{
	  FILE* f = thePrinter.getOutput ();
	  if (f != stderr)
	    fclose (f);
	  if (!yyvsp[0].s)
	    f = stderr;
	  else if (!(f = fopen (yyvsp[0].s, "w+")))
	    perror (yyvsp[0].s), f = stderr;
	  thePrinter.setOutput (f);
	  delete[] yyvsp[0].s;
	;
    break;}
case 31:
#line 843 "parser/marde.y"
{ help (); ;
    break;}
case 34:
#line 850 "parser/marde.y"
{ currentTransition = isNet () ? new class Transition (0, 0) : 0; ;
    break;}
case 35:
#line 852 "parser/marde.y"
{
	  if (currentTransition) {
	    fireTransition (*currentTransition, currentState, visual);
	    delete currentTransition; currentTransition = 0;
	  }
	;
    break;}
case 36:
#line 860 "parser/marde.y"
{ currentTransition = isState (yyvsp[-1].i) ? new class Transition (0, 0) : 0; ;
    break;}
case 37:
#line 862 "parser/marde.y"
{
	  if (currentTransition) {
	    fireTransition (*currentTransition, currentState, visual);
	    delete currentTransition; currentTransition = 0;
	  }
	;
    break;}
case 38:
#line 870 "parser/marde.y"
{ exiting = true; YYABORT; ;
    break;}
case 39:
#line 875 "parser/marde.y"
{ yyval.ia = new card_t[2]; yyval.ia[0] = 1; yyval.ia[1] = yyvsp[0].i; ;
    break;}
case 40:
#line 878 "parser/marde.y"
{
	  if ((yyval.ia = yyvsp[-1].ia)) {
	    yyval.ia = new card_t[*yyval.ia + 2];
	    memcpy (yyval.ia, yyvsp[-1].ia, (1 + *yyvsp[-1].ia) * sizeof *yyvsp[-1].ia);
	    delete[] yyvsp[-1].ia;
	    yyval.ia[++(*yyval.ia)] = yyvsp[0].i;
	  }
	;
    break;}
case 41:
#line 888 "parser/marde.y"
{ delete[] yyvsp[-1].ia; yyval.ia = 0; ;
    break;}
case 42:
#line 893 "parser/marde.y"
{ yyval.ia = new card_t[2]; yyval.ia[0] = 1; yyval.ia[1] = yyvsp[0].i; ;
    break;}
case 43:
#line 896 "parser/marde.y"
{
	  if ((yyval.ia = yyvsp[-1].ia)) {
	    yyval.ia = new card_t[*yyval.ia + 2];
	    memcpy (yyval.ia, yyvsp[-1].ia, (1 + *yyvsp[-1].ia) * sizeof *yyvsp[-1].ia);
	    delete[] yyvsp[-1].ia;
	    yyval.ia[++(*yyval.ia)] = yyvsp[0].i;
	  }
	;
    break;}
case 44:
#line 907 "parser/marde.y"
{ visual = 0; ;
    break;}
case 45:
#line 910 "parser/marde.y"
{ visual++; ;
    break;}
case 46:
#line 915 "parser/marde.y"
{ lsts (yyvsp[0].s); ;
    break;}
case 47:
#line 918 "parser/marde.y"
{ unfold (yyvsp[0].s); ;
    break;}
case 48:
#line 921 "parser/marde.y"
{ dump (visual); ;
    break;}
case 49:
#line 924 "parser/marde.y"
{ analyze (yyvsp[0].i, true); ;
    break;}
case 50:
#line 927 "parser/marde.y"
{ analyze (yyvsp[0].i, false); ;
    break;}
case 51:
#line 930 "parser/marde.y"
{
	  if (yyvsp[0].s) {
	    currentState = CARD_T_MAX;
	    if (model (yyvsp[0].s, 0, false)) analyze (0, true);
	  }
	;
    break;}
case 52:
#line 938 "parser/marde.y"
{
	  if (yyvsp[0].s) {
	    currentState = CARD_T_MAX;
	    if (model (yyvsp[0].s, 0, false)) analyze (0, false);
	  }
	;
    break;}
case 53:
#line 946 "parser/marde.y"
{
	  if (!yyvsp[0].s && (yyvsp[0].s = getenv ("HOME"))) yyvsp[0].s = newString (yyvsp[0].s);
	  if (yyvsp[0].s && chdir (yyvsp[0].s)) perror (yyvsp[0].s); delete[] yyvsp[0].s;
	;
    break;}
case 54:
#line 952 "parser/marde.y"
{ delete[] translator; translator = yyvsp[0].s; ;
    break;}
case 55:
#line 955 "parser/marde.y"
{
#ifdef EXPR_COMPILE
	  delete[] compiledir; compiledir = yyvsp[0].s;
#else // EXPR_COMPILE
	  delete[] yyvsp[0].s; deerror ("no support for code generator");
#endif // EXPR_COMPILE
	;
    break;}
case 56:
#line 966 "parser/marde.y"
{ strong (currentState, 0); ;
    break;}
case 57:
#line 969 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) strong (currentState, yyvsp[0].expr); ;
    break;}
case 58:
#line 972 "parser/marde.y"
{ strong (yyvsp[0].i, 0); ;
    break;}
case 59:
#line 975 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) strong (yyvsp[-1].i, yyvsp[0].expr); ;
    break;}
case 60:
#line 978 "parser/marde.y"
{ if ((yyvsp[-1].expr = ensureBool (yyvsp[-1].expr))) strong (yyvsp[0].i, yyvsp[-1].expr); ;
    break;}
case 61:
#line 981 "parser/marde.y"
{ terminal (); ;
    break;}
case 62:
#line 984 "parser/marde.y"
{ allcomps (visual); ;
    break;}
case 63:
#line 989 "parser/marde.y"
{ eval (yyvsp[-1].i, yyvsp[0].expr, visual); ;
    break;}
case 64:
#line 992 "parser/marde.y"
{ eval (currentState, yyvsp[0].expr, visual); ;
    break;}
case 65:
#line 996 "parser/marde.y"
{ yyval.i = currentState; ;
    break;}
case 66:
#line 999 "parser/marde.y"
{
	  if ((yyval.i = yyvsp[-1].i) != currentState) {
	    thePrinter.printRaw ("ignoring extraneous state qualifier ");
	    thePrinter.printState (yyvsp[0].i);
	    thePrinter.finish ();
	  }
	  else
	    yyval.i = yyvsp[0].i;
	;
    break;}
case 67:
#line 1011 "parser/marde.y"
{ yyval.i = currentState; ;
    break;}
case 68:
#line 1014 "parser/marde.y"
{
	  if ((yyval.i = yyvsp[-1].i) != currentState) {
	    thePrinter.printRaw ("ignoring extraneous state qualifier ");
	    thePrinter.printState (yyvsp[0].i);
	    thePrinter.finish ();
	  }
	  else
	    yyval.i = yyvsp[0].i;
	;
    break;}
case 69:
#line 1025 "parser/marde.y"
{ deerror ("expecting a state number"); yyval.i = yyvsp[-1].i; ;
    break;}
case 70:
#line 1028 "parser/marde.y"
{
	  deerror ("expecting a state number");
	  delete[] yyvsp[0].s; yyval.i = yyvsp[-1].i;
	;
    break;}
case 71:
#line 1035 "parser/marde.y"
{ yyval.flag = false; ;
    break;}
case 72:
#line 1038 "parser/marde.y"
{ if (yyvsp[-1].flag) deerror ("ignoring extraneous `!'"); yyval.flag = true; ;
    break;}
case 75:
#line 1048 "parser/marde.y"
{
	  if (isNet ())
	    for (unsigned place = net->getNumPlaces (); place--; )
	      net->getPlace (place).setSuppressed (hide = !yyvsp[0].flag);
	;
    break;}
case 76:
#line 1055 "parser/marde.y"
{ if (isNet ()) hide = !yyvsp[0].flag; ;
    break;}
case 78:
#line 1061 "parser/marde.y"
{
	  if (net && yyvsp[0].s) {
	    if (const class Place* p = net->getPlace (yyvsp[0].s))
	      p->setSuppressed (hide);
	    else {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	    }
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 79:
#line 1075 "parser/marde.y"
{
	  if (net && yyvsp[0].s) {
	    if (const class Place* p = net->getPlace (yyvsp[0].s))
	      p->setSuppressed (hide);
	    else {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	    }
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 80:
#line 1091 "parser/marde.y"
{ if (isState (yyvsp[0].i)) currentState = yyvsp[0].i; ;
    break;}
case 81:
#line 1094 "parser/marde.y"
{
	  if (visual) {
	    thePrinter.printRaw ("ignoring extraneous `visual'");
	    thePrinter.finish ();
	  }
	  if (isState (yyvsp[0].i)) currentState = yyvsp[0].i;
	;
    break;}
case 82:
#line 1105 "parser/marde.y"
{ path_sc (yyvsp[-1].i, yyvsp[-2].i, yyvsp[0].expr, visual); ;
    break;}
case 83:
#line 1108 "parser/marde.y"
{ path_cs (yyvsp[-1].i, yyvsp[-2].i, yyvsp[0].expr, visual); ;
    break;}
case 84:
#line 1111 "parser/marde.y"
{
	  if (!yyvsp[-1].ia || !*yyvsp[-1].ia)
	    yyvsp[0].expr->destroy ();
	  else if (*yyvsp[-1].ia <= 2) {
	    card_t src = *yyvsp[-1].ia >= 2 ? yyvsp[-1].ia[2] : currentState, dest = yyvsp[-1].ia[1];
	    path_ss (src, dest, yyvsp[0].expr, visual);
	  }
	  else
	    path_sl (currentState, yyvsp[-1].ia, yyvsp[0].expr, visual);
	  delete[] yyvsp[-1].ia;
	;
    break;}
case 85:
#line 1124 "parser/marde.y"
{
	  if ((yyvsp[-1].expr = ensureBool (yyvsp[-1].expr)))
	    path_se (currentState, *yyvsp[-1].expr, yyvsp[0].expr, visual);
	;
    break;}
case 86:
#line 1130 "parser/marde.y"
{ if ((yyvsp[-2].expr = ensureBool (yyvsp[-2].expr))) path_se (yyvsp[-1].i, *yyvsp[-2].expr, yyvsp[0].expr, visual); ;
    break;}
case 87:
#line 1133 "parser/marde.y"
{ if ((yyvsp[-1].expr = ensureBool (yyvsp[-1].expr))) rpath_se (yyvsp[-2].i, *yyvsp[-1].expr, yyvsp[0].expr, visual); ;
    break;}
case 88:
#line 1137 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 89:
#line 1140 "parser/marde.y"
{
	  if ((yyval.expr = yyvsp[-2].expr)) {
	    deerror ("ignoring extraneous path condition");
	    yyvsp[0].expr->destroy ();
	  }
	  else
	    yyval.expr = ensureBool (yyvsp[0].expr);
	;
    break;}
case 90:
#line 1151 "parser/marde.y"
{
	  if (!yyvsp[0].s || !isNet ()) yyval.type = NULL;
	  else if ((yyval.type = net->getType (yyvsp[0].s)));
	  else if (!strcmp (yyvsp[0].s, "bool"))
	    yyval.type = &Net::getBoolType ();
	  else if (!strcmp (yyvsp[0].s, "int"))
	    yyval.type = &Net::getIntType ();
	  else if (!strcmp (yyvsp[0].s, "unsigned"))
	    yyval.type = &Net::getCardType ();
	  else if (!strcmp (yyvsp[0].s, "char"))
	    yyval.type = &Net::getCharType ();
	  else {
	    thePrinter.printRaw ("undefined type ");
	    thePrinter.printQuoted (yyvsp[0].s);
	    thePrinter.finish ();
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 91:
#line 1173 "parser/marde.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 92:
#line 1176 "parser/marde.y"
{ yyval.s = NULL; ;
    break;}
case 93:
#line 1180 "parser/marde.y"
{ yyval.s = NULL; ;
    break;}
case 94:
#line 1183 "parser/marde.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 95:
#line 1187 "parser/marde.y"
{ deerror ("missing name"); yyval.s = NULL; ;
    break;}
case 96:
#line 1190 "parser/marde.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 101:
#line 1203 "parser/marde.y"
{ currentType = yyvsp[-2].type; ;
    break;}
case 102:
#line 1205 "parser/marde.y"
{ defun (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr); ;
    break;}
case 103:
#line 1208 "parser/marde.y"
{
	  currentType = yyvsp[-4].type;
	  if (emptyParsed && currentArity)
	    deerror ("extraneous delimiter after formal parameter list");
	  emptyParsed = false;
	;
    break;}
case 104:
#line 1215 "parser/marde.y"
{ defun (yyvsp[-6].type, yyvsp[-5].s, yyvsp[0].expr); ;
    break;}
case 105:
#line 1220 "parser/marde.y"
{
	  if (currentArity || currentParameters)
	    delete[] yyvsp[0].s;
	  else
	    addParameter (yyvsp[-1].type, yyvsp[0].s), emptyParsed = false;
	;
    break;}
case 106:
#line 1228 "parser/marde.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s && emptyParsed)
	    deerror ("extraneous delimiter in parameter list");
	  addParameter (yyvsp[-1].type, yyvsp[0].s);
	  emptyParsed = false;
	;
    break;}
case 107:
#line 1236 "parser/marde.y"
{
	  if (emptyParsed)
	    deerror ("extraneous delimiter in parameter list");
	  emptyParsed = true;
	;
    break;}
case 108:
#line 1242 "parser/marde.y"
{ if (!currentArity && !currentParameters) emptyParsed = true; ;
    break;}
case 111:
#line 1250 "parser/marde.y"
{ isOutputArc = false; ;
    break;}
case 113:
#line 1254 "parser/marde.y"
{ isOutputArc = true; ;
    break;}
case 115:
#line 1258 "parser/marde.y"
{ currentType = &Net::getBoolType (); ;
    break;}
case 116:
#line 1260 "parser/marde.y"
{ currentType = NULL; ;
    break;}
case 117:
#line 1264 "parser/marde.y"
{ yyval.flag = false; ;
    break;}
case 118:
#line 1267 "parser/marde.y"
{ yyval.flag = true; ;
    break;}
case 119:
#line 1270 "parser/marde.y"
{
	  if (!yyvsp[-2].flag)
	    deerror ("extraneous delimiter before variable definition");
	  yyval.flag = true;
	;
    break;}
case 120:
#line 1277 "parser/marde.y"
{
	  if (!yyvsp[-1].flag)
	    deerror ("extraneous delimiter in variable definition list");
	  yyval.flag = false;
	;
    break;}
case 121:
#line 1287 "parser/marde.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s && currentTransition) {
	    if (currentTransition->getVariable (yyvsp[0].s)) {
	      thePrinter.printRaw ("redefinition of variable ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      delete[] yyvsp[0].s;
	    }
	    else
	      currentTransition->addVariable (yyvsp[0].s, *yyvsp[-1].type, false, false);
	  }
	  else
	    delete[] yyvsp[0].s;
	;
    break;}
case 122:
#line 1303 "parser/marde.y"
{ beginAny (yyvsp[-2].type, yyvsp[-1].s, false); ;
    break;}
case 123:
#line 1305 "parser/marde.y"
{ endAny (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr)->destroy (); ;
    break;}
case 128:
#line 1321 "parser/marde.y"
{ currentType = yyvsp[-1].place ? &yyvsp[-1].place->getType () : NULL; ;
    break;}
case 129:
#line 1323 "parser/marde.y"
{
	  if (!yyvsp[-3].place || !currentTransition)
	    yyvsp[0].marking->destroy ();
	  else if (yyvsp[0].marking) {
	    if (class Arc* arc =
		currentTransition->getArc (isOutputArc, *yyvsp[-3].place))
	      arc->append (*yyvsp[0].marking);
	    else
	      currentTransition->addArc (*new class Arc
					 (isOutputArc, *yyvsp[0].marking, *yyvsp[-3].place));
	  }
	  currentType = NULL;
	;
    break;}
case 132:
#line 1346 "parser/marde.y"
{
	  if ((yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr))) && currentTransition) {
	    if (yyvsp[0].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<const class Constant*>(yyvsp[0].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      if (bool (static_cast<const class LeafValue&>(v))) {
		dewarn ("gate is constantly enabled");
		yyvsp[0].expr->destroy ();
	      }
	      else {
		dewarn ("gate is constantly disabled");
		currentTransition->addGate (*yyvsp[0].expr);
	      }
	    }
	    else
	      currentTransition->addGate (*yyvsp[0].expr);
	  }
	  else
	    yyvsp[0].expr->destroy ();
	;
    break;}
case 133:
#line 1371 "parser/marde.y"
{ yyval.marking = ensureMarking (yyvsp[0].expr, currentType); ;
    break;}
case 134:
#line 1376 "parser/marde.y"
{ yyval.marking = yyvsp[0].marking; ;
    break;}
case 135:
#line 1379 "parser/marde.y"
{
	  if ((yyval.marking = yyvsp[-2].marking) && yyvsp[0].marking)
	    yyval.marking->append (*yyvsp[0].marking);
	  else if (yyvsp[0].marking)
	    yyval.marking = yyvsp[0].marking;
	;
    break;}
case 136:
#line 1389 "parser/marde.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 137:
#line 1392 "parser/marde.y"
{ yyvsp[-1].expr = ensureMarking (yyvsp[-1].expr, currentType); ;
    break;}
case 138:
#line 1394 "parser/marde.y"
{
	  assert (!yyvsp[-3].expr || yyvsp[-3].expr->getKind () == Expression::eMarking);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].marking)
	    static_cast<class Marking*>(yyval.expr)->append (*yyvsp[0].marking);
	  else if (yyvsp[0].marking)
	    yyval.expr = yyvsp[0].marking;
	;
    break;}
case 139:
#line 1404 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 140:
#line 1407 "parser/marde.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 141:
#line 1411 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 142:
#line 1414 "parser/marde.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 143:
#line 1417 "parser/marde.y"
{ yyval.expr = namedComponent (yyvsp[-1].s, NULL); ;
    break;}
case 144:
#line 1420 "parser/marde.y"
{ yyval.expr = namedComponent (yyvsp[-2].s, yyvsp[0].expr); ;
    break;}
case 145:
#line 1425 "parser/marde.y"
{
	  if (currentContextType && !YYRECOVERING ()) {
	    assert (!currentComponent);

	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);
		class VectorExpression* v = new class VectorExpression (*type);

		if (!yyvsp[0].expr) {
		  deerror ("missing expression for first vector component");
		  v->destroy (), yyval.expr = NULL;
		}
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = v, v->setComponent (currentComponent, *yyvsp[0].expr);
		else
		  v->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tBuffer:
	      {
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);
		class BufferExpression* b = new class BufferExpression (*type);

		if (!yyvsp[0].expr)
		  yyval.expr = b;
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = b, b->append (*yyvsp[0].expr);
		else
		  b->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tStruct:
	      {
		if (!yyvsp[0].expr &&
		    !static_cast<const class StructType*>(currentContextType)
		    ->getSize ())
		  yyval.expr = CSE (new class Constant
			    (*new class StructValue (*currentContextType)));
		else {
		  class StructExpression* s =
		    new class StructExpression (*currentContextType);

		  if (isCompatible (yyvsp[0].expr, *s))
		    yyval.expr = s, s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		  else
		    s->destroy (), yyvsp[0].expr->destroy (),
		      yyval.expr = NULL, currentType = NULL;
		}
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 146:
#line 1490 "parser/marde.y"
{
	  if ((yyval.expr = yyvsp[-2].expr) && currentContextType && !YYRECOVERING ()) {
	    assert (currentComponent > 0);
	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		assert (yyval.expr->getKind () == Expression::eVector);
		class VectorExpression* v =
		  static_cast<class VectorExpression*>(yyval.expr);
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);

		if (currentComponent < type->getSize ()) {
		  if (!yyvsp[0].expr) {
		    thePrinter.printRaw ("missing array item ");
		    thePrinter.print (currentComponent);
		    thePrinter.finish ();
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    v->setComponent (currentComponent, *yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for array ");
		  printType (*type);
		  thePrinter.finish ();
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tBuffer:
	      {
		assert (yyval.expr->getKind () == Expression::eBuffer);
		class BufferExpression* b =
		  static_cast<class BufferExpression*>(yyval.expr);
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);

		if (b->hasCapacity ()) {
		  if (!yyvsp[0].expr || !b->getSize ()) {
		    thePrinter.printRaw ("missing buffer item ");
		    thePrinter.print (yyvsp[0].expr ? currentComponent : 0);
		    thePrinter.finish ();
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    b->append (*yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for buffer ");
		  printType (*type);
		  thePrinter.finish ();
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tStruct:
	      {
		assert (yyval.expr->getKind () == Expression::eStruct);
		class StructExpression* s =
		  static_cast<class StructExpression*>(yyval.expr);

		if (isCompatible (yyvsp[0].expr, *s))
		  s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		else
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (),
		    yyval.expr = NULL, currentType = NULL;
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 147:
#line 1575 "parser/marde.y"
{ yyval.expr = NULL; deerror ("missing expression"); ;
    break;}
case 148:
#line 1578 "parser/marde.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 149:
#line 1583 "parser/marde.y"
{ yyval.expr = ensureExpr (yyvsp[0].expr); ;
    break;}
case 150:
#line 1588 "parser/marde.y"
{ yyval.i = 0; ;
    break;}
case 151:
#line 1591 "parser/marde.y"
{ yyval.i = 1; ;
    break;}
case 152:
#line 1594 "parser/marde.y"
{ yyval.i = 2; ;
    break;}
case 153:
#line 1597 "parser/marde.y"
{ yyval.i = 3; ;
    break;}
case 154:
#line 1602 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 155:
#line 1605 "parser/marde.y"
{
	  yyval.expr = NULL;
	  if (yyvsp[-1].s) {
	    if (class Function* f = getFunction (yyvsp[-1].s)) {
	      if (!(yyval.expr = fold (f->expand (NULL)))) {
		thePrinter.printRaw ("could not expand nullary function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.finish ();
	      }
	    }
	    else {
	      thePrinter.printRaw ("there is no nullary function ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	    }
	  }
	;
    break;}
case 156:
#line 1624 "parser/marde.y"
{
	  class Function* f = NULL;
	  if (yyvsp[-1].s && !(f = getFunction (yyvsp[-1].s))) {
	    thePrinter.printRaw ("there is no function ");
	    thePrinter.printQuoted (yyvsp[-1].s);
	    thePrinter.finish ();
	  }
	  delete[] yyvsp[-1].s;
	  functionStack.push (f);
	;
    break;}
case 157:
#line 1635 "parser/marde.y"
{
	  assert (!functionStack.empty ());
	  if (class Function* f = functionStack.top ()) {
	    yyval.expr = NULL;
	    if (yyvsp[-1].exprList && !(yyval.expr = fold (f->expand (yyvsp[-1].exprList)))) {
	      thePrinter.printRaw ("could not expand function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.finish ();
	    }
	  }
	  else
	    yyval.expr = NULL;
	  yyvsp[-1].exprList->destroy ();
	  functionStack.pop ();
	;
    break;}
case 158:
#line 1652 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
	;
    break;}
case 159:
#line 1658 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), false)));
	;
    break;}
case 160:
#line 1664 "parser/marde.y"
{ yyval.expr = yyvsp[0].place ? CSE (new class PlaceContents (*yyvsp[0].place)) : NULL; ;
    break;}
case 161:
#line 1667 "parser/marde.y"
{ yyval.expr = resolveName (yyvsp[0].s); ;
    break;}
case 162:
#line 1670 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getCardType (), yyvsp[0].i)));
	;
    break;}
case 163:
#line 1676 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getCharType (), yyvsp[0].c)));
	;
    break;}
case 164:
#line 1682 "parser/marde.y"
{ yyval.expr = CSE (new class Undefined (Undefined::fError)); ;
    break;}
case 165:
#line 1685 "parser/marde.y"
{ yyval.expr = CSE (new class Undefined (Undefined::fFatalError)); ;
    break;}
case 166:
#line 1688 "parser/marde.y"
{
	  structLevels.push (StructLevel
			     (currentContextType, currentComponent));

	  if (!currentType) {
	    deerror ("cannot determine type of structured expression");
	    currentContextType = NULL, currentComponent = 0;
	  }
	  else {
	    assert (!structLevels.empty () || !currentComponent);
	    currentContextType = currentType;
	    currentComponent = 0;

	    switch (currentType->getKind ()) {
	    case Type::tStruct:
	      currentType =
		static_cast<const class StructType*>(currentContextType)
		->getSize ()
		? &(*static_cast<const class StructType*>(currentContextType))
		[currentComponent]
		: NULL;
	      break;
	    case Type::tVector:
	      currentType =
		&static_cast<const class VectorType*>(currentContextType)
		->getItemType ();

	      if (dewarnings) {
		const class Type& indexType =
		  static_cast<const class VectorType*>(currentContextType)
		  ->getIndexType ();

		switch (indexType.getKind ()) {
		case Type::tInt:
		case Type::tCard:
		case Type::tBool:
		case Type::tChar:
		case Type::tEnum:
		case Type::tId:
		  if (const class Constraint* constraint =
		      indexType.getConstraint ()) {
		    if (constraint->size () <= 1)
		      break;
		  }
		  else
		    break;
		default:
		  dewarn ("initializing an array indexed by something else"
			  " than a simple continuous type");
		}
	      }

	      break;
	    case Type::tBuffer:
	      currentType =
		&static_cast<const class BufferType*>(currentContextType)
		->getItemType ();

	      break;
	    default:
	      deerror ("cannot determine type of structured expression");
	      currentType = currentContextType = NULL;
	    }
	  }
	;
    break;}
case 167:
#line 1755 "parser/marde.y"
{
	  yyval.expr = yyvsp[-1].expr;
	  if (currentContextType) {
	    if (yyval.expr) {
	      switch (yyval.expr->getKind ()) {
	      case Expression::eStruct:
		{
		  class StructExpression* s =
		    static_cast<class StructExpression*>(yyval.expr);
		  if (s->getNextType ()) {
		    thePrinter.printRaw ("structure ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" not fully initialized");
		    thePrinter.finish ();
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      case Expression::eConstant:
	      case Expression::eBuffer:
		break;

	      case Expression::eVector:
		{
		  card_t diff =
		    static_cast<const class VectorType*>(currentContextType)
		    ->getSize () - currentComponent;

		  if (diff) {
		    thePrinter.print (diff);
		    thePrinter.printRaw (diff == 1
					 ? " element of array "
					 : " elements of array ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" left uninitialized");
		    thePrinter.finish ();

		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      default:
		assert (false);
	      }
	    }

	    StructLevel p = structLevels.top ();
	    currentType = currentContextType;
	    currentContextType = p.first;
	    currentComponent = p.second;
	  }
	  else
	    currentComponent = 0;

	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 168:
#line 1818 "parser/marde.y"
{ pushTypeContext (yyvsp[0].type); ;
    break;}
case 169:
#line 1820 "parser/marde.y"
{
	  if ((yyval.expr = yyvsp[0].expr) && yyval.expr->getKind () == Expression::eMarking &&
	      yyval.expr->getType () == currentType);
	  else if ((yyval.expr = noMarking (yyval.expr)) && currentType) {
	    if (!yyval.expr->getType ()) {
	      deerror ("expression to cast has no type");
	      yyval.expr->destroy (), yyval.expr = NULL;
	    }
	    else
	      makeCompatible (yyval.expr, *currentType, true);
	  }
	  popTypeContext ();
	;
    break;}
case 170:
#line 1835 "parser/marde.y"
{
	  StructLevel p (currentContextType, currentComponent);
	  structLevels.push (p);
	  currentContextType = currentType;
	  currentType = NULL, currentComponent = 0;

	  if (yyvsp[-1].s && currentContextType &&
	      currentContextType->getKind () == Type::tUnion) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if ((currentType = (*u)[yyvsp[-1].s]))
	      currentComponent = u->getIndex (yyvsp[-1].s);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (*u);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	    }
	  }
	  else if (yyvsp[-1].s)
	    deerror ("cannot assign the component of a non-union type");

	  delete[] yyvsp[-1].s;
	;
    break;}
case 171:
#line 1862 "parser/marde.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && currentType) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if (isCompatible (yyvsp[0].expr, currentType))
	      yyval.expr = fold (new class UnionExpression (*u, *yyvsp[0].expr,
						    currentComponent));
	    else {
	      thePrinter.printRaw ("type mismatch for ");
	      printType (*u);
	      thePrinter.printRaw (" component ");
	      thePrinter.printQuoted (u->getComponentName (currentComponent));
	      thePrinter.finish ();

	      yyvsp[0].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  assert (!structLevels.empty ());
	  StructLevel p = structLevels.top ();
	  currentType = currentContextType;
	  currentContextType = p.first;
	  currentComponent = p.second;
	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 172:
#line 1895 "parser/marde.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () && yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType* u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());

	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionTypeExpression (*yyvsp[-2].expr,
							  u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      deerror ("cannot determine the component of a non-union value");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 173:
#line 1929 "parser/marde.y"
{ if ((yyval.expr = noMarking (yyvsp[0].expr))) { yyval.expr->setAtomic (true); yyval.expr = CSE (yyval.expr); } ;
    break;}
case 174:
#line 1932 "parser/marde.y"
{ beginAny (yyvsp[-1].type, NULL, false); ;
    break;}
case 175:
#line 1934 "parser/marde.y"
{ yyval.expr = endAny (yyvsp[-3].type, NULL, yyvsp[0].expr); ;
    break;}
case 176:
#line 1937 "parser/marde.y"
{ beginAny (yyvsp[-2].type, yyvsp[-1].s, false); ;
    break;}
case 177:
#line 1939 "parser/marde.y"
{ yyval.expr = endAny (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr); ;
    break;}
case 178:
#line 1942 "parser/marde.y"
{ yyval.expr = newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 179:
#line 1945 "parser/marde.y"
{ yyval.expr = newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 180:
#line 1948 "parser/marde.y"
{ yyval.expr = newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr); ;
    break;}
case 181:
#line 1951 "parser/marde.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 182:
#line 1954 "parser/marde.y"
{ yyval.expr = newNotExpression (newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 183:
#line 1957 "parser/marde.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr)); ;
    break;}
case 184:
#line 1960 "parser/marde.y"
{
	  if (yyvsp[-2].expr && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    const class BufferType* type =
	      static_cast<const class BufferType*>(yyvsp[-2].expr->getType ());
	    if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && (yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) &&
		isCompatible (yyvsp[0].expr, &type->getItemType ())) {
	      if (yyvsp[-2].expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyvsp[-2].expr);
		yyval.expr = fold (new class BufferWrite (b->getBuffer (), *yyvsp[0].expr,
						  &b->getIndex ()));
		b->destroy ();
	      }
	      else
		yyval.expr = fold (new class BufferWrite (*yyvsp[-2].expr, *yyvsp[0].expr, NULL));
	    }
	    else
	      yyvsp[-2].expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bPlus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 185:
#line 1984 "parser/marde.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[-2].expr))) {
	      class Expression* index = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		index = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, ensureCard (yyvsp[0].expr), index));
	    }
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bMinus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 186:
#line 2003 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bDiv, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 187:
#line 2006 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMul, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 188:
#line 2009 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMod, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 189:
#line 2012 "parser/marde.y"
{
	  if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNot, *yyval.expr));
	;
    break;}
case 190:
#line 2018 "parser/marde.y"
{
	  if (yyvsp[0].type) {
	    card_t num = yyvsp[0].type->getNumValues ();
	    assert (num > 0);
	    if (num == CARD_T_MAX) {
	      deerror ("type has too many values to count");
	      yyval.expr = NULL;
	    }
	    else
	      yyval.expr = CSE (new class Constant
			(*new class LeafValue
			 (Net::getCardType (), num)));
	  }
	  else
	    yyval.expr = NULL;
	;
    break;}
case 191:
#line 2036 "parser/marde.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = CSE (new class Constant (yyvsp[0].type->getFirstValue ()));
	  else
	    yyval.expr = NULL;
	;
    break;}
case 192:
#line 2044 "parser/marde.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = CSE (new class Constant (yyvsp[0].type->getLastValue ()));
	  else
	    yyval.expr = NULL;
	;
    break;}
case 193:
#line 2052 "parser/marde.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uPred, *yyval.expr));
	;
    break;}
case 194:
#line 2058 "parser/marde.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uSucc, *yyval.expr));
	;
    break;}
case 195:
#line 2064 "parser/marde.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && yyvsp[0].expr->getType () &&
	      yyvsp[0].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[0].expr))) {
	      class Expression* index = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		index = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, 0, index));
	    }
	  }
	  else if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNeg, *yyval.expr));
	;
    break;}
case 196:
#line 2083 "parser/marde.y"
{ yyval.expr = newBufferUnop (BufferUnop::bPeek, yyvsp[0].expr); ;
    break;}
case 197:
#line 2086 "parser/marde.y"
{ yyval.expr = newBufferUnop (BufferUnop::bUsed, yyvsp[0].expr); ;
    break;}
case 198:
#line 2089 "parser/marde.y"
{ yyval.expr = newBufferUnop (BufferUnop::bFree, yyvsp[0].expr); ;
    break;}
case 199:
#line 2092 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRol, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 200:
#line 2095 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 201:
#line 2098 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bAnd, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 202:
#line 2101 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bXor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 203:
#line 2104 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bOr, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 204:
#line 2107 "parser/marde.y"
{
	  yyvsp[-2].expr = noMarking (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].exprList) {
	    if (!yyvsp[-2].expr->getType ()) {
	      deerror ("left-hand-side of ? has no type");
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () != yyvsp[0].exprList->size ()) {
	      thePrinter.printRaw ("left-hand-side of ? has ");
	      thePrinter.print (yyvsp[-2].expr->getType ()->getNumValues ());
	      thePrinter.printRaw ("!=");
	      thePrinter.print (yyvsp[0].exprList->size ());
	      thePrinter.printRaw (" possible values");
	      thePrinter.finish ();
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () == 1) {
	      dewarn ("left-hand-side of ? has only one possible value");
	      yyval.expr = (*yyvsp[0].exprList)[0].copy (); yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy ();
	    }
	    else
	      yyval.expr = fold (new class IfThenElse (*yyvsp[-2].expr, *yyvsp[0].exprList));
	  }
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 205:
#line 2136 "parser/marde.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr))) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tVector) {
	      deerror ("left-hand-side of .{[index]expr} is not an array");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    else
	      pushTypeContext (&static_cast<const class VectorType*>
			       (yyvsp[-3].expr->getType ())->getIndexType ());
	  }
	;
    break;}
case 206:
#line 2149 "parser/marde.y"
{
	  if (yyvsp[-6].expr)
	    currentType = &static_cast<const class VectorType*>(yyvsp[-6].expr->getType ())
	      ->getItemType ();
	;
    break;}
case 207:
#line 2155 "parser/marde.y"
{
	  if (yyvsp[-9].expr) {
	    currentType = yyvsp[-9].expr->getType ();
	    const class VectorType& type =
	      *static_cast<const class VectorType*>(currentType);

	    if (makeCompatible (yyvsp[-4].expr, type.getIndexType ()) &&
		makeCompatible (yyvsp[-1].expr, type.getItemType ()))
	      yyval.expr = fold (new class VectorAssign (*yyvsp[-9].expr, *yyvsp[-4].expr, *yyvsp[-1].expr));
	    else
	      yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyvsp[-9].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	;
    break;}
case 208:
#line 2173 "parser/marde.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr)) && yyvsp[0].s) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tStruct) {
	      deerror ("left-hand-side of .{comp expr} is not a struct");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-3].expr->getType ());
	    if (const class Type* ct = type[yyvsp[0].s])
	      pushTypeContext (ct);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (type);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();

	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	  }
	  else
	    yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	;
    break;}
case 209:
#line 2198 "parser/marde.y"
{
	  if (yyvsp[-6].expr) {
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-6].expr->getType ());
	    currentType = type[yyvsp[-3].s];
	    if (makeCompatible (yyvsp[-1].expr, *currentType))
	      yyval.expr =
		fold (new class StructAssign (*yyvsp[-6].expr, type.getIndex (yyvsp[-3].s), *yyvsp[-1].expr));
	    else
	      yyvsp[-1].expr->destroy (), yyvsp[-6].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	  delete[] yyvsp[-3].s;
	;
    break;}
case 210:
#line 2216 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () &&
		yyvsp[-2].expr->getType ()->getKind () == Type::tStruct) {
	      const class StructType *s =
		static_cast<const class StructType*>(yyvsp[-2].expr->getType ());
	      if ((*s)[yyvsp[0].s])
		yyval.expr = fold (new class StructComponent (*yyvsp[-2].expr, s->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*s);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else if (yyvsp[-2].expr->getType () &&
		     yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType *u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());
	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionComponent (*yyvsp[-2].expr, u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      deerror ("only unions and structs have components");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;
	;
    break;}
case 211:
#line 2263 "parser/marde.y"
{
	  if ((yyvsp[-1].expr = ensureExpr (yyvsp[-1].expr)) && yyvsp[-1].expr->getType ()) {
	    switch (yyvsp[-1].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-1].expr->getType ());
		pushTypeContext (&type->getIndexType ());
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-1].expr->getKind () == Expression::eBufferIndex)
		deerror ("a buffer index has already been specified");
	      break;
	    default:
	      deerror ("only vector-typed expressions can be indexed");
	      yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	    }
	  }
	  else if (yyvsp[-1].expr) {
	    deerror ("no type for indexed expression");
	    yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	  }
	;
    break;}
case 212:
#line 2288 "parser/marde.y"
{
	  if (yyvsp[-4].expr) {
	    switch (yyvsp[-4].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-4].expr->getType ());
		popTypeContext ();

		if (isCompatible (yyvsp[-1].expr, &type->getIndexType ()))
		  yyval.expr = fold (new class VectorIndex (*yyvsp[-4].expr, *yyvsp[-1].expr));
		else
		  yyval.expr = NULL, yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy ();
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-4].expr->getKind () == Expression::eBufferIndex)
		yyvsp[-1].expr->destroy (), yyval.expr = yyvsp[-4].expr;
	      else
		yyval.expr = yyvsp[-1].expr ? CSE (new class BufferIndex (*yyvsp[-4].expr, *yyvsp[-1].expr)) : yyvsp[-4].expr;
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr = NULL, yyvsp[-1].expr->destroy ();
	;
    break;}
case 213:
#line 2318 "parser/marde.y"
{ yyval.expr = newNotExpression (yyvsp[0].expr); ;
    break;}
case 214:
#line 2321 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (true, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 215:
#line 2331 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 216:
#line 2341 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, newNotExpression (yyvsp[-2].expr), yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 217:
#line 2351 "parser/marde.y"
{
	  yyval.expr = newNotExpression
	    (newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)));
	;
    break;}
case 218:
#line 2357 "parser/marde.y"
{ yyval.expr = newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)); ;
    break;}
case 219:
#line 2360 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Finally, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 220:
#line 2368 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Globally, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 221:
#line 2376 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Next, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 222:
#line 2384 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = CSE (new class TemporalBinop (TemporalBinop::Until,
					       *yyvsp[-2].expr, *yyvsp[0].expr));
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 223:
#line 2395 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = CSE (new class TemporalBinop (TemporalBinop::Release,
					       *yyvsp[-2].expr, *yyvsp[0].expr));
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 224:
#line 2406 "parser/marde.y"
{ yyval.expr = CSE (new class EmptySet); ;
    break;}
case 225:
#line 2409 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sSubset, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 226:
#line 2412 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sIntersection, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 227:
#line 2415 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sMinus, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 228:
#line 2418 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sUnion, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 229:
#line 2421 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sEquals, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 230:
#line 2424 "parser/marde.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cCard, yyvsp[0].expr); ;
    break;}
case 231:
#line 2427 "parser/marde.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMin, yyvsp[0].expr); ;
    break;}
case 232:
#line 2430 "parser/marde.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMax, yyvsp[0].expr); ;
    break;}
case 233:
#line 2433 "parser/marde.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 234:
#line 2436 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureCard (yyvsp[-2].expr);
	  class Marking* m = ensureMarking (yyvsp[0].expr, currentType);

	  if ((yyval.expr = m) && yyvsp[-2].expr) {
	    if (yyvsp[-2].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[-2].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      card_t mult = card_t (static_cast<const class LeafValue&>(v));
	      if (!mult) {
		deerror ("zero multiplicity");
		yyvsp[-2].expr->destroy (), m->destroy ();
		yyval.expr = m = NULL;
	      }
	      else if (mult == 1)
		yyvsp[-2].expr->destroy ();
	      else {
		for (;;) {
		  if (class Expression* c = m->getMultiplicity ()) {
		    class Expression* card =
		      fold (new class BinopExpression (BinopExpression::bMul,
						       *yyvsp[-2].expr, *c));
		    m->setMultiplicity (card);
		  }
		  else
		    m->setMultiplicity (yyvsp[-2].expr);

		  if ((m = const_cast<class Marking*>(m->getNext ())))
		    yyvsp[-2].expr = CSE (new class Constant
			      (*new class LeafValue (*yyvsp[-2].expr->getType (), mult)));
		  else
		    break;
		}
	      }
	    }
	    else {
	      if (m->getNext ())
		yyval.expr = m = static_cast<class Marking*>
		  (CSE (new class Marking (m->getPlace (), m)));

	      class Expression* card = yyvsp[-2].expr;

	      if (class Expression* c = m->getMultiplicity ())
		card = fold
		  (new class BinopExpression (BinopExpression::bMul, *yyvsp[-2].expr, *c));
	      m->setMultiplicity (card);
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy ();
	;
    break;}
case 235:
#line 2490 "parser/marde.y"
{ beginQuantifier (yyvsp[0].s, yyvsp[-1].type); ;
    break;}
case 236:
#line 2492 "parser/marde.y"
{ continueQuantifier (ASSERT1 (yyvsp[-3].type)); ;
    break;}
case 237:
#line 2494 "parser/marde.y"
{ yyval.expr = endQuantifier (yyvsp[-5].s, yyvsp[-6].type, yyvsp[-3].expr, yyvsp[-1].i, yyvsp[0].expr); ;
    break;}
case 238:
#line 2497 "parser/marde.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, false); ;
    break;}
case 239:
#line 2500 "parser/marde.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, true); ;
    break;}
case 240:
#line 2503 "parser/marde.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    dewarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ())
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 241:
#line 2515 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr));
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].expr && yyvsp[-5].s) {
	    yyvsp[0].expr = CSE (yyvsp[0].expr);
	    if (dewarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:subset is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    if (yyvsp[0].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[0].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      bool result = bool (static_cast<const class LeafValue&>(v));
	      yyvsp[0].expr->destroy ();
	      dewarn (result
		      ? "subset criterion always passes"
		      : "subset criterion always fails");
	      if (!result)
		yyval.expr->destroy (), yyval.expr = CSE (new class EmptySet);
	    }
	    else
	      yyval.expr = CSE (new class Submarking
			(*currentVariables.top (), *yyvsp[-3].expr, *yyvsp[0].expr));
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 242:
#line 2551 "parser/marde.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    dewarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ())
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 243:
#line 2563 "parser/marde.y"
{
	  yyvsp[0].expr = ensureExpr (yyvsp[0].expr);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[-5].s && yyvsp[0].expr) {
	    yyvsp[0].expr = CSE (yyvsp[0].expr);
	    if (dewarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:mapping is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    yyval.expr = CSE (new class Mapping
		      (*currentVariables.top (), NULL, *yyvsp[-3].expr, *yyvsp[0].expr));
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 244:
#line 2586 "parser/marde.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    dewarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-5].s && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-5].s, Net::getCardType (), false));
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else {
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	;
    break;}
case 245:
#line 2604 "parser/marde.y"
{
	  yyvsp[0].expr = ensureCard (yyvsp[0].expr);
	  yyval.expr = yyvsp[-3].expr;
	  if (yyvsp[-7].s && yyvsp[-5].s) {
	    class VariableDefinition* token = currentVariables.top ();
	    currentVariables.pop ();
	    class VariableDefinition* mult = currentVariables.top ();
	    currentVariables.pop ();
	    if (yyval.expr && yyvsp[0].expr) {
	      yyvsp[0].expr = CSE (yyvsp[0].expr);
	      if (dewarnings) {
		class VariableSet vars;
		vars.insert (*token);
		vars.insert (*mult);
		if (!yyvsp[0].expr->depends (vars, false)) {
		  thePrinter.printRaw ("Warning:mapping depends neither on ");
		  thePrinter.printQuoted (token->getName ());
		  thePrinter.printRaw (" nor ");
		  thePrinter.printQuoted (mult->getName ());
		  thePrinter.finish ();
		}
	      }
	      yyval.expr = CSE (new class Mapping
			(*token, mult, *yyvsp[-3].expr, *yyvsp[0].expr));
	    }
	    else
	      yyvsp[0].expr->destroy ();
	  }
	  else
	    yyvsp[0].expr->destroy ();
	;
    break;}
case 246:
#line 2638 "parser/marde.y"
{
	  if (class Function* f = functionStack.top ()) {
	    if (!f->getArity ())
	      yyval.exprList = new class ExpressionList;
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" expects ");
	      thePrinter.print (f->getArity ());
	      thePrinter.printRaw (", not zero arguments");
	      thePrinter.finish ();
	      yyval.exprList = NULL;
	    }
	  }
	  else
	    yyval.exprList = NULL;
	;
    break;}
case 247:
#line 2656 "parser/marde.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (f->getArity ())
	      type = &(*f)[0].getType ();
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" takes no arguments");
	      thePrinter.finish ();
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 248:
#line 2673 "parser/marde.y"
{
	  if (currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      (yyval.exprList = new class ExpressionList)->append (*yyvsp[0].expr);
	    else {
	      yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 249:
#line 2689 "parser/marde.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (yyvsp[-1].exprList) {
	      if (f->getArity () > yyvsp[-1].exprList->size ())
		type = &(*f)[yyvsp[-1].exprList->size ()].getType ();
	      else {
		thePrinter.printRaw ("function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.printRaw (" takes only ");
		thePrinter.print (f->getArity ());
		thePrinter.printRaw (" arguments");
		thePrinter.finish ();
	      }
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 250:
#line 2710 "parser/marde.y"
{
	  if ((yyval.exprList = yyvsp[-3].exprList) && currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      yyval.exprList->append (*yyvsp[0].expr);
	    else {
	      yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 251:
#line 2726 "parser/marde.y"
{ if ((yyval.exprList = yyvsp[-1].exprList)) deerror ("extraneous comma in argument list"); ;
    break;}
case 252:
#line 2732 "parser/marde.y"
{
	  if ((yyvsp[0].expr = noMarking (yyvsp[0].expr)))
	    (yyval.exprList = new class ExpressionList)->prepend (*yyvsp[0].expr);
	  else {
	    yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	;
    break;}
case 253:
#line 2741 "parser/marde.y"
{
	  yyvsp[0].expr = noMarking (yyvsp[0].expr);
	  if ((yyval.exprList = yyvsp[-2].exprList) && yyvsp[0].expr) {
	    if (yyval.exprList->getType () && yyvsp[0].expr->getType () &&
		yyval.exprList->getType () != yyvsp[0].expr->getType ()) {
	      deerror ("incompatible types in ?: expression");
	      yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	    else
	      yyval.exprList->prepend (*yyvsp[0].expr);
	  }
	  else {
	    yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	;
    break;}
case 254:
#line 2760 "parser/marde.y"
{
	  if (yyvsp[0].s && isNet ()) {
	    if (!(yyval.place = net->getPlace (yyvsp[0].s))) {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	    }
	  }
	  else
	    yyval.place = NULL;
	  delete[] yyvsp[0].s;
	;
    break;}
case 255:
#line 2776 "parser/marde.y"
{ yyval.place = yyvsp[0].place; ;
    break;}
case 257:
#line 2783 "parser/marde.y"
{ deerror ("ignoring extraneous `place'"); ;
    break;}
}

#line 727 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 2786 "parser/marde.y"


#include "cmdline.h"

const char*
deline ()
{
  static char prompt1[22], prompt2[22];
  if (currentState == CARD_T_MAX) {
    memcpy (prompt1, "$", 2);
    memcpy (prompt2, ">", 2);
  }
  else {
    sprintf (prompt1, "@%u$", currentState);
    sprintf (prompt2, "@%u>", currentState);
  }
  extern volatile bool interrupted;
  if (interrupted)
    fputs ("[Interrupt]\n", stderr);
  interrupted = true;
  const char* line = cmdline (prompt1, prompt2);
  interrupted = false;
  return line;
}

#ifdef HAS_READLINE
/** Duplicate a string
 * @param s	string to be duplicated
 * @return	a copy of the string allocated with malloc ()
 */
inline static char*
dupstr (const char* s)
{
  size_t length = strlen (s) + 1;
  char* r = static_cast<char*>(malloc (length));
  if (r)
    memcpy (r, s, length);
  return r;
}

/** flag: is quoting desired? */
extern int rl_filename_completion_desired;
/** character to be appended to completed words (0 or ' ') */
extern int rl_completion_append_character;
/** Iterate through all file names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a file name, or NULL if no match
 */
extern "C" char* filename_completion_function (const char* text, int state);

/** Iterate through all keywords starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a command name, or NULL if no match
 */
extern "C" char*
marde_keywords (const char* text, int state)
{
  /** Keywords of the language */
  static const char* keywords[] = {
    "model \"", "graph \"", "breadth", "depth", "strong", "path",
    "terminal", "components", "cd", "translator \"", "compiledir \"",
    "visual", "dump", "eval", "hide", "show",
    "succ", "pred", "go", "stats", "time", "help", "log",
    "function", "exit", "union", "is", "until",
    "release", "subset", "intersect", "equals", "minus", "atom",
    "empty", "place \"", "true", "false", "undefined", "fatal",
    "cardinality", "min", "max"
  };

  /** Number of the last keyword searched */
  static unsigned i;
  /** Length of the string */
  static size_t length;

  if (!state) {
    i = 0;
    length = strlen (text);
  }
  else {
    assert (i <= (sizeof keywords) / sizeof *keywords);
    assert (length == strlen (text));
  }

  while (i < (sizeof keywords) / sizeof *keywords) {
    const char* name = keywords[i++];
    if (!strncmp (name, text, length)) {
      if (name[strlen (name) - 1] == '"')
	rl_completion_append_character = 0;
      return dupstr (name);
    }
  }

  return NULL;
}

/** Iterate through place names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a place name, or NULL if no match
 */
extern "C" char*
marde_placenames (const char* text, int state)
{
  /** Number of the last place searched */
  static unsigned place;
  /** Length of the string */
  static size_t length;

  if (!state) {
    place = 0;
    length = strlen (text);
    rl_filename_completion_desired = 1;
  }
  else {
    assert (net && place <= net->getNumPlaces ());
    assert (length == strlen (text));
    assert (rl_filename_completion_desired);
  }

  if (!net)
    return NULL;

  while (place < net->getNumPlaces ()) {
    const char* name = net->getPlace (place++).getName ();
    if (!strncmp (name, text, length))
      return dupstr (name);
  }

  return NULL;
}

/** Iterate through type names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a type name, or NULL if no match
 */
extern "C" char*
marde_typenames (const char* text, int state)
{
  /** Last type searched */
  static Net::TypeMap::const_iterator type;
  /** Length of the string */
  static size_t length;

  if (!net)
    return NULL;

  if (!state) {
    type = net->beginTypename ();
    length = strlen (text);
    rl_filename_completion_desired = 1;
  }
  else {
    assert (length == strlen (text));
    assert (rl_filename_completion_desired);
  }

  while (type != net->endTypename ()) {
    const char* name = (type++)->first;
    if (!strncmp (name, text, length))
      return dupstr (name);
  }

  return NULL;
}

/** Iterate through other names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a name
 */
extern "C" char*
marde_othernames (const char* text, int state)
{
  return NULL;
}

/** Completion function of readline
 * @param word		word to be completed
 * @param completer	the completion function
 */
extern "C" char **
completion_matches (const char* word,
		    char* (*completer) (const char*, int));

/** Complete place or type names
 * @param word		word to be completed
 * @param start		start offset of the string to be completed
 * @param end		end offset of the string to be completed
 */
extern "C" char**
marde_completer (const char* word, int start, int end)
{
  /** The line gathered so far */
  extern char* rl_line_buffer;
  assert (start >= 0 && start <= end);
  assert (size_t (end - start) == strlen (word));
  assert (size_t (end) <= strlen (rl_line_buffer));
  rl_completion_append_character = ' ';

  if ((start >= 6 && !memcmp (&rl_line_buffer[start - 6], "place ", 6)) ||
      (start >= 7 && !memcmp (&rl_line_buffer[start - 7], "place \"", 7)))
    return completion_matches (word, marde_placenames);
  if ((start >= 3 && !memcmp (&rl_line_buffer[start - 3], "is ", 3)) ||
      (start >= 4 && !memcmp (&rl_line_buffer[start - 4], "is \"", 4)))
    return completion_matches (word, marde_typenames);
  if ((start >= 3 && !memcmp (&rl_line_buffer[start - 3], "cd ", 3)) ||
      (start >= 4 && (!memcmp (&rl_line_buffer[start - 4], "cd \"", 4) ||
		      !memcmp (&rl_line_buffer[start - 4], "log ", 4))) ||
      (start >= 5 && !memcmp (&rl_line_buffer[start - 5], "log \"", 5)) ||
      (start >= 6 && (!memcmp (&rl_line_buffer[start - 6], "model ", 6) ||
		      !memcmp (&rl_line_buffer[start - 6], "graph ", 6))) ||
      (start >= 7 && (!memcmp (&rl_line_buffer[start - 7], "model \"", 7) ||
		      !memcmp (&rl_line_buffer[start - 7], "graph \"", 7) ||
		      !memcmp (&rl_line_buffer[start - 7], "depth \"", 7))) ||
      (start >= 9 && (!memcmp (&rl_line_buffer[start - 9],
			       "breadth \"", 9))) ||
      (start >= 11 && (!memcmp (&rl_line_buffer[start - 11],
				"translator ", 11) ||
		       !memcmp (&rl_line_buffer[start - 11],
				"compiledir ", 11))) ||
      (start >= 12 && (!memcmp (&rl_line_buffer[start - 12],
				"translator \"", 12) ||
		       !memcmp (&rl_line_buffer[start - 12],
				"compiledir \"", 12))))
    return completion_matches (word, filename_completion_function);
  return completion_matches (word, marde_keywords);
}
#endif // HAS_READLINE

void
dereset ()
{
  command = true;
  currentExpressions.clear ();
  delete[] currentParameters;
  currentParameters = 0;
  while (!functionStack.empty ()) functionStack.pop ();
  currentContextTransition = 0;
  currentType = currentContextType = 0;
  currentComponent = 0;
  while (!typeStack.empty ()) typeStack.pop ();
  emptyParsed = false;
  while (!structLevels.empty ()) structLevels.pop ();
  if (currentState == CARD_T_MAX) currentState = 0;
  delexreset ();
#ifdef HAS_READLINE
  init_cmdline ("marde", marde_completer, marde_othernames);
#endif // HAS_READLINE
}

static void
help (void)
{
  fputs ("Query language commands:\n"
	 "\tmodel \"MODELNAME\"\n"
	 "\tgraph \"GRAPHFILE\"\n"
	 "\t(breadth|depth) [STATE]\n"
	 "\t(breadth|depth) \"MODELNAME\"\n"
	 "\tlsts [\"OUTFILE\"]\n"
	 "\tunfold M?([lmpr](OUTFILE)?)?\n"
	 "\thide [!][[place] PLACENAME (, [place] PLACENAME)*]\n"
	 "\t[visual] [STATE] [eval] formula\n"
	 "\t[visual] show [STATE]\n"
	 "\t[visual] [show] COMP [expr]\n"
	 "\t[visual] (succ|pred)[!] [STATE]\n"
	 "\t[visual] (succ|pred) COMP\n"
	 "\t[go] STATE\n"
	 "\tstrong [STATE] [expr]\n"
	 "\tterminal\n"
	 "\t[visual] components\n"
	 "\t[visual] path (STATE|COMP|expr) [STATE]\n"
	 "\t[visual] path STATE (COMP|expr)\n"
	 "\t[visual] [STATE] trans {transition-definition}\n"
	 "\tstats\n"
	 "\ttime\n"
	 "\tcd \"DIRECTORY\"\n"
	 "\ttranslator [\"COMMAND\"]\n"
	 "\tcompiledir [\"DIRECTORY\"]\n"
	 "\thelp\n"
	 "\tfunction {function-definition}\n"
	 "\tlog [\"LOGFILE\"]\n"
	 "\texit\n",
	 stderr);
}

static bool
isNet (void)
{
  if (net)
    return true;
  deerror ("no model has been loaded");
  return false;
}

static void
printType (const class Type& type)
{
  if (const char* name = type.getName ())
    thePrinter.print (name);
  else
    type.display (thePrinter);
}

static void pushTypeContext (const class Type* type)
{
  StructLevel p (currentContextType, currentComponent);
  structLevels.push (p);
  StructLevel q (currentType, 0);
  structLevels.push (q);

  currentType = type;
  currentContextType = NULL, currentComponent = 0;
}

static void popTypeContext ()
{
  StructLevel p = structLevels.top ();
  structLevels.pop ();
  currentType = p.first;
  assert (!p.second);
  p = structLevels.top ();
  structLevels.pop ();
  currentContextType = p.first;
  currentComponent = p.second;
}

static const class VariableDefinition*
getParameter (char* name)
{
  for (unsigned i = 0; i < currentArity; i++) {
    if (!strcmp (currentParameters[i]->getName (), name))
      return currentParameters[i];
  }

  return NULL;
}

static void
addParameter (const class Type* type, char* name)
{
  if (!type || !name) {
    delete[] name;
    return;
  }

  if (getParameter (name)) {
    thePrinter.printRaw ("ignoring redefinition of parameter ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
    delete[] name;
    return;
  }

  if (dewarnings) {
    const char* shadow = 0;
    if (getConstant (name) || getConstantFunction (name))
      shadow = " shadows a constant";
    else if (net->getType (name))
      shadow = " shadows a type name";

    if (shadow) {
      thePrinter.printRaw ("Warning:parameter ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (shadow);
      thePrinter.finish ();
    }
  }

  class VariableDefinition** v =
    new class VariableDefinition*[currentArity + 1];
  assert (!currentArity || currentParameters);
  assert (currentArity || !currentParameters);

  memcpy (v, currentParameters, currentArity * sizeof *v);
  delete[] currentParameters;
  currentParameters = v;
  currentParameters[currentArity++] =
    new class VariableDefinition (name, *type, false);
}

static class Function*
getFunction (const char* name)
{
  if (!isNet ())
    return NULL;
  class Function* f = currentContextTransition
    ? currentContextTransition->getFunction (name)
    : NULL;
  return f ? f : net->getFunction (name);
}

static class Function*
getConstantFunction (const char* name)
{
  if (!isNet ())
    return NULL;
  class Function* f = currentContextTransition
    ? currentContextTransition->getFunction (name)
    : NULL;
  if (!f || f->getArity ())
    f = net->getFunction (name);
  return f && f->getArity () ? NULL : f;
}

static const class Constant*
getConstant (const char* name)
{
  if (!isNet ())
    return NULL;
  const class Constant* c = currentContextTransition
    ? currentContextTransition->getConstant (name)
    : NULL;
  return c ? c : net->getConstant (name);
}

static const class Expression*
getProposition (char* name)
{
  if (net)
    for (unsigned i = net->getNumProps (); i--; )
      if (!strcmp (net->getPropName (i), name))
	return &net->getProp (i);
  return 0;
}

static const class VariableDefinition*
getVariable (char* name)
{
  assert (name != NULL);

  const class VariableDefinition* v = getParameter (name);
  const class Function* f = getConstantFunction (name);
  const class Constant* c = getConstant (name);

  if (v || (v = currentVariables.find (name)))
    goto found;

  if (!currentTransition) {
    if (currentContextTransition &&
	(v = currentContextTransition->getVariable (name)));
    else if (!f && !c &&
	     !(currentType && currentType->getKind () == Type::tEnum &&
	       static_cast<const class EnumType*>(currentType)
	       ->getValue (name)) &&
	     !getProposition (name)) {
      thePrinter.printRaw ("undefined variable ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
    }
    delete[] name;
  }
  else if ((v = currentTransition->getVariable (name))) {
  found:
    delete[] name;
  }
  else if (f || c)
    delete[] name;
  else if (!currentType) {
    thePrinter.printRaw ("cannot determine the type of variable ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
    delete[] name;
  }
  else {
    assert (currentType != NULL);

    if (dewarnings && net->getType (name)) {
      thePrinter.printRaw ("Warning:variable ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a type name");
      thePrinter.finish ();
    }

    if (currentType->getKind () != Type::tEnum ||
	!static_cast<const class EnumType*>(currentType)->getValue (name))
      v = &currentTransition->addVariable (name, *currentType, false, false);
    else
      delete[] name;
  }

  return v;
}

static class Expression*
resolveName (char* name)
{
  const class Constant* c = getConstant (name);
  class Function* f = getConstantFunction (name);
  const card_t*const i =
    (currentType && currentType->getKind () == Type::tEnum)
    ? static_cast<const class EnumType*>(currentType)->getValue (name)
    : NULL;
  const class Expression* prop = getProposition (name);

  if (const class VariableDefinition* d = getVariable (name))
    return static_cast<class Variable*>(CSE (new class Variable (*d)));
  else if (c)
    return CSE (const_cast<class Constant*>(c)->copy ());
  else if (class Expression* expr = f ? f->expand (NULL) : NULL)
    return fold (expr);
  if (i)
    return enumValue (*static_cast<const class EnumType*>(currentType), *i);
  if (prop)
    return CSE (const_cast<class Expression*>(prop)->copy ());

  return NULL;
}

static class Expression*
ensureSet (class Expression* expr,
	   const class Type* type)
{
  return !expr || expr->isSet () ? expr : ensureMarking (expr, type);
}

static class Marking*
ensureMarking (class Expression* expr,
	       const class Type* type)
{
  if (!expr)
    return NULL;
  else if (expr->getKind () == Expression::eUndefined) {
    deerror ("undefined marking expressions are not allowed");
    expr->destroy ();
    return NULL;
  }

  assert (expr->getType () || expr->getKind () == Expression::eEmptySet);

  if (expr->getKind () == Expression::eMarking)
    return static_cast<class Marking*>(expr);
  else if (expr->isSet () || expr->isBasic ()) {
    if (!type || makeCompatible (expr, *type)) {
      class Marking* m = new class Marking (NULL);
      m->setToken (expr);
      return m;
    }
    else
      return NULL;
  }
  else {
    deerror ("marking expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
noMarking (class Expression* expr)
{
  if (expr && expr->getKind () == Expression::eMarking) {
    deerror ("marking expression not allowed here");
    expr->destroy ();
    return NULL;
  }

  return expr;
}

static class Expression*
ensureExpr (class Expression* expr)
{
  expr = noMarking (expr);

  if (expr && !expr->isBasic ()) {
    deerror ("basic expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureBool (class Expression* expr, bool undefined)
{
  expr = noMarking (expr);

  if (!expr)
    return NULL;

  if (expr->getKind () == Expression::eUndefined) {
    if (undefined)
      return expr;
    deerror ("undefined or fatal expression is not meaningful here");
    expr->destroy (); return NULL;
  }

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBool) {
    deerror ("boolean expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureInt (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tCard:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getIntType (), true));
    else if (expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    deerror ("signed integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tInt:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType ())
      return expr;
    /* fall through */
  default:
    deerror ("unsigned integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureIntCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType () ||
	     expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    deerror ("integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureBuffer (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBuffer) {
    deerror ("buffer expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureOrdered (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (!isOrdered (*expr->getType ())) {
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
enumValue (const class EnumType& type, card_t value)
{
  class LeafValue* e = new class LeafValue (type, value);
  if (type.isConstrained (*e))
    return CSE (new class Constant (*e));
  else {
    thePrinter.printRaw ("enumeration constant ");
    if (const char* c = type.getEnumName (value)) {
      thePrinter.print (c);
      thePrinter.delimiter ('=');
    }
    thePrinter.print (value);
    thePrinter.printRaw (" out of range for type ");
    printType (type);
    thePrinter.finish ();
    delete e;
    return NULL;
  }
}

static class Expression*
namedComponent (char* name, class Expression* expr)
{
  if (!name) {
    expr->destroy ();
    return NULL;
  }

  if (!currentContextType || currentContextType->getKind () != Type::tStruct) {
    thePrinter.printRaw ("named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" can only be used with a struct");
    thePrinter.finish ();
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  const class StructType& type =
    static_cast<const class StructType&>(*currentContextType);

  if (currentComponent < type.getSize ()) {
    const char* comp = type.getComponentName (currentComponent);
    if (strcmp (name, comp)) {
      thePrinter.printRaw ("expecting named component ");
      thePrinter.printQuoted (comp);
      thePrinter.printRaw (" instead of ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      expr->destroy ();
      delete[] name;
      return NULL;
    }
  }
  else {
    thePrinter.printRaw ("extraneous named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" at end of struct");
    thePrinter.finish ();
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  delete[] name;
  return expr;
}

static void
beginAny (const class Type*& type, char* name,
	  bool hidden)
{
  if (type) {
    if (currentTransition) {
      if (name && currentTransition->getVariable (name)) {
	thePrinter.printRaw ("output variable ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (" shadows another variable");
	thePrinter.finish ();
	type = NULL; delete[] name;
      }
      else if (name)
	currentTransition->addVariable (name, *type, true, hidden);
      card_t size = type->getNumValues ();
      if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
	thePrinter.printRaw ("type ");
	printType (*type);
	thePrinter.printRaw (" has too many (");
	thePrinter.print (size);
	thePrinter.printRaw (") values for non-determinism");
	if (size && size < CARD_T_MAX)
	  thePrinter.printRaw (" (try -q0)");
	thePrinter.finish ();
      }
    }
    else {
      deerror ("non-determinism is only allowed on output arcs");
      type = NULL; delete[] name;
    }
  }
  else
    delete[] name;

  pushTypeContext (type);
}

static class Variable*
endAny (const class Type* type,
	char* name,
	class Expression* condition)
{
  class Variable* var;
  popTypeContext ();

  if (type) {
    if (!condition || (condition = ensureBool (ensureExpr (condition)))) {
      var = static_cast<class Variable*>
	(CSE (new class Variable
	      (currentTransition->addOutputVariable (*type, name,
						     condition))));
      assert (var != NULL);
      if (dewarnings && condition) {
	class VariableSet vars;
	vars.insert (var->getVariable ());
	if (!condition->depends (vars, false)) {
	  thePrinter.printRaw ("Warning:condition is independent of ");
	  thePrinter.printQuoted (var->getVariable ().getName ());
	  thePrinter.finish ();
        }
      }
    }
    else
      var = NULL, condition->destroy ();
  }
  else
    var = NULL, condition->destroy ();
  return var;
}

static void
beginQuantifier (char* name, const class Type* type)
{
  if (name && type) {
    if (dewarnings) {
      const char* shadow = 0;
      if (currentVariables.find (name))
        shadow = " shadows another quantifier";
      else if ((currentContextTransition &&
		currentContextTransition->getVariable (name)))
	shadow = " shadows a transition variable";
      else if (getConstant (name))
	shadow = " shadows a constant";
      else if (currentType && currentType->getKind () == Type::tEnum &&
	       static_cast<const class EnumType*>(currentType)->
	       getValue (name))
	shadow = " shadows an enumeration constant";
      else if (net->getType (name))
	shadow = " shadows a type name";

      if (shadow) {
	thePrinter.printRaw ("quantifier ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (shadow);
	thePrinter.finish ();
      }
    }

    card_t size = type->getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      thePrinter.printRaw ("type ");
      printType (*type);
      thePrinter.printRaw (" has too many (");
      thePrinter.print (size);
      thePrinter.printRaw (") values for quantification");
      if (size && size < CARD_T_MAX)
	thePrinter.printRaw (" (try -q0)");
      thePrinter.finish ();
    }
    currentVariables.push (new class VariableDefinition (name, *type, true));
  }

  struct TypeContext tc = {
    currentContextType,
    currentType,
    currentComponent
  };
  typeStack.push (tc);

  currentContextType = NULL;
  currentComponent = 0;
  currentType = type;
}

static void
continueQuantifier (ASSERT1 (const class Type* type))
{
  assert (!currentContextType);
  assert (currentType == type);
  assert (!typeStack.empty ());
  struct TypeContext tc = typeStack.top ();
  typeStack.pop ();

  currentContextType = tc.context;
  currentType = tc.component;
  currentComponent = tc.numComponent;
}

static class Expression*
endQuantifier (char* name,
	       const class Type* type,
	       class Expression* condition,
	       unsigned kind,
	       class Expression* expr)
{
  if (name && type && expr && kind) {
    class VariableDefinition* var = currentVariables.top ();
    currentVariables.pop ();

    card_t size = var->getType ().getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      condition->destroy ();
      expr->destroy ();
      delete var;
      return NULL;
    }

    if ((condition = ensureBool (ensureExpr (condition))) && dewarnings) {
      class VariableSet vars;
      vars.insert (*var);
      if (!condition->depends (vars, false)) {
	thePrinter.printRaw ("Warning:condition is independent of ");
	thePrinter.printQuoted (var->getName ());
	thePrinter.finish ();
      }
    }

    class Valuation v;
    switch (kind) {
    case 1:
      if (class Marking* m = ensureMarking (expr, currentType)) {
	expr = m->quantify (v, currentContextTransition,
			    *var, condition, false);
	m->destroy ();
	delete var;
	if (!expr) {
	  if (check (v))
	    deerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return CSE (expr);
      }
      else
	expr = NULL;
      break;
    case 2:
    case 3:
      if ((expr = ensureBool (expr))) {
	class Expression* e =
	  BooleanBinop::quantify (kind != 2,
				  *expr, v, currentContextTransition,
				  *var, condition, false);
	expr->destroy ();
	delete var;
	if (!e) {
	  if (check (v))
	    deerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return CSE (e);
      }
      break;
    default:
      assert (false);
    }

    expr->destroy ();
    delete var;
    return NULL;
  }
  else {
    condition->destroy (), expr->destroy ();
    if (name && type) {
      class VariableDefinition* var = currentVariables.top ();
      currentVariables.pop ();
      delete var;
    }
    else
      delete[] name;
    return NULL;
  }
}

static class Expression*
quantifierVariable (char* prefix, char* quant, bool pred)
{
  char p = pred ? ',' : '.';
  if (!prefix) {
    delete[] prefix;
    delete[] quant;
    return NULL;
  }
  class VariableDefinition* var;
  if (currentVariables.empty ())
    var = NULL;
  else if (quant)
    var = currentVariables.find (quant);
  else
    var = currentVariables.top ();

  if (!var) {
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    if (quant) {
      thePrinter.printRaw (": quantifier ");
      thePrinter.print (quant);
      thePrinter.printRaw (" not found");
    }
    else
      thePrinter.printRaw (": no quantifier found");
    thePrinter.finish ();
  }
  else if (!var->isAggregate ()) {
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.printRaw (": variable ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (" is not a quantifier");
    thePrinter.finish ();
  }
  else if (!currentContextTransition) {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": cannot define ");
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.printRaw (" outside transition");
    thePrinter.finish ();
  }
  else if (!currentType) {
    if (const class VariableDefinition* qvar = var->findChild (prefix)) {
      delete[] quant;
      delete[] prefix;
      return CSE (new class Variable (*qvar, pred));
    }
    else {
      thePrinter.printRaw ("quantifier ");
      thePrinter.print (var->getName ());
      thePrinter.printRaw (": cannot determine the type of ");
      thePrinter.delimiter (p);
      thePrinter.print (prefix);
      thePrinter.finish ();
    }
  }
  else if (const class VariableDefinition* qvar =
	   var->addChild (prefix, *currentType)) {
    delete[] quant;
    return CSE (new class Variable (*qvar, pred));
  }
  else {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": contradictory type for ");
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.finish ();
  }

  delete[] prefix;
  delete[] quant;
  return NULL;
}

static bool
makeCompatible (class Expression*& expr,
		const class Type& type,
		bool casting)
{
  if (!expr) return false;
  if (expr->getType () == &type ||
      expr->getKind () == Expression::eEmptySet)
    return true;
  assert (!!expr->getType ());
  const class Type& srcType = *expr->getType ();
  if (((Typecast::isCastable (type) &&
	Typecast::isCastable (srcType)) ||
       Type::isCompatible (srcType, type)) &&
      expr->isBasic () && !expr->isSet ()) {
    bool isConstant = expr->getKind () == Expression::eConstant;
    expr = CSE (new class Typecast (type, *expr));
    if (!casting && dewarnings &&
	((!srcType.isAssignable (type) &&
	  srcType.getKind () != Type::tCard &&
	  srcType.getKind () != Type::tInt &&
	  type.getKind () != Type::tCard &&
	  type.getKind () != Type::tInt) ||
	 (!isConstant && !srcType.isAlwaysAssignable (type)))) {
      thePrinter.printRaw ("Warning:implicit conversion from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
    }
    if (isConstant && !(expr = fold (expr))) {
      thePrinter.printRaw ("cannot convert constant from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
      return false;
    }
    return true;
  }
  else {
    thePrinter.printRaw ("cannot convert from ");
    printType (srcType);
    thePrinter.printRaw (" to ");
    printType (type);
    thePrinter.finish ();
    return false;
  }
}

static bool
isCompatible (class Expression*& expr,
	      const class Type* type)
{
  if (!type) {
    deerror ("too many components for struct");
    return false;
  }

  if (!expr)
    return false;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    return false;
  }

  return makeCompatible (expr, *type);
}

static bool
isCompatible (class Expression*& expr,
	      const class StructExpression& s)
{
  const class Type* type = s.getNextType ();
  const char* structName = s.getType ()->getName ();

  if (!type) {
    if (structName) {
      thePrinter.printRaw ("too many components for struct ");
      thePrinter.printQuoted (structName);
    }
    else
      thePrinter.printRaw ("too many components for struct");
    thePrinter.finish ();
    return false;
  }

  const char* comp =
    static_cast<const class StructType*>(s.getType ())
    ->getComponentName (s.size ());

  if (!expr) {
    if (structName) {
      thePrinter.printRaw ("error in expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("error in expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    return false;
  }

  if (!expr->getType ()) {
    if (structName) {
      thePrinter.printRaw ("expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.printRaw (" has no type");
    thePrinter.finish ();
    return false;
  }

  if (!makeCompatible (expr, *type))
    return false;

  if (!expr->getType ()->isAlwaysAssignable (*type)) {
    if (Type::isCompatible (*expr->getType (), *type))
      thePrinter.printRaw ("too broad type for struct ");
    else
      thePrinter.printRaw ("type mismatch for struct ");
    if (structName) {
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    return false;
  }
  else if (expr->getType () != type)
    expr = CSE (new class Typecast (*type, *expr));

  return true;
}

static bool
isOrdered (const class Type& type)
{
  if (!type.isOrdered ()) {
    thePrinter.printRaw ("unordered type ");
    printType (type);
    thePrinter.finish ();
    return false;
  }

  return true;
}

static bool
check (const class Valuation& v)
{
  bool ok = true;

  switch (v.getError ()) {
  case errDiv0:
    ok = false, deerror ("division by zero"); break;
  case errOver:
    ok = false, deerror ("overflow"); break;
  case errMod:
    ok = false, deerror ("modulus error"); break;
  case errShift:
    ok = false, deerror ("shift error"); break;
  case errConst:
    ok = false, deerror ("constraint violation"); break;
  case errUnion:
    ok = false, deerror ("union violation"); break;
  case errBuf:
    ok = false, deerror ("buffer violation"); break;
  case errCard:
    ok = false, deerror ("cardinality overflow"); break;
  case errComp:
    assert (false);
  case errNone:
  case errVar:
  case errUndef:
  case errFatal:
    break;
  }

  return ok;
}

static class Expression*
fold (class Expression* expr)
{
  if (expr && expr->isBasic ()) {
    class Valuation v;
    if (class Value* value = expr->eval (v)) {
      assert (v.isOK ());
      expr->destroy ();
      return CSE (new class Constant (*value));
    }
    else {
      if (!check (v)) {
	expr->destroy ();
	return NULL;
      }
      else {
	if (v.getError () == errFatal) {
	  expr->destroy ();
	  return CSE (new class Undefined (Undefined::fFatalError));
	}
	if (v.getError () == errUndef) {
	  expr->destroy ();
	  return CSE (new class Undefined (Undefined::fError));
	}

	assert (v.getError () == errVar);
	return CSE (expr);
      }
    }
  }
  else
    return CSE (expr);
}

static void
defun (const class Type* type,
       char* name,
       class Expression* expr)
{
  currentType = NULL;
  if (type && name && expr) {
    if (net->getFunction (name)) {
      thePrinter.printRaw ("ignoring redefinition of function ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      delete[] name, expr->destroy ();
    }
    else if (isCompatible (expr, type)) {
      class Function* f =
	new class Function (name, currentArity, currentParameters, expr);
      net->addFunction (*f);

      if (dewarnings && net->getType (name)) {
	thePrinter.printRaw ("Warning:function ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (" shadows a type name");
	thePrinter.finish ();
	for (unsigned i = 0; i < currentArity; i++) {
	  class VariableSet vars;
	  vars.insert (*currentParameters[i]);
	  if (!expr->depends (vars, false)) {
	    thePrinter.printRaw ("Warning:function ");
	    thePrinter.printQuoted (name);
	    thePrinter.printRaw (" does not use parameter ");
	    thePrinter.printQuoted (currentParameters[i]->getName ());
	    thePrinter.finish ();
	  }
	}
      }
    }
    else
      delete[] name, expr->destroy ();
  }
  else
    delete[] name, expr->destroy ();
  currentArity = 0, currentParameters = 0;
  emptyParsed = false;
}

static class Expression*
newRelopExpression (bool equal,
		    class Expression* left,
		    class Expression* right)
{
  left = ensureExpr (left); right = ensureExpr (right);
  if (!left || !right);
  else if (left->getType () != right->getType ()) {
    if (left->getKind () == Expression::eConstant &&
	makeCompatible (left, *right->getType ()))
      goto ok;
    if (right->getKind () == Expression::eConstant &&
	makeCompatible (right, *left->getType ()))
      goto ok;
    deerror ("expressions in comparison have different types");
  }
  else if (!left->getType ()->isOrdered () && !equal)
    deerror ("cannot compare expressions of unordered type");
  else {
  ok:
    return fold (RelopExpression::construct (equal, *left, *right));
  }

  left->destroy ();
  right->destroy ();
  return 0;
}

static class Expression*
newBinopExpression (enum BinopExpression::Op op,
		    class Expression* left,
		    class Expression* right)
{
  if (left && left->getType () &&
      left->getType ()->getKind () == Type::tVector) {
    bool shl = false;
    switch (op) {
    case BinopExpression::bRol:
      shl = true;
      break;
    case BinopExpression::bRor:
      shl = false;
      break;
    default:
      ensureIntCard (left)->destroy ();
      ensureIntCard (right)->destroy ();
      return NULL;
    }
    if ((left = ensureExpr (left)) && (right = ensureCard (right))) {
      size_t size =
	static_cast<const class VectorType*>(left->getType ())->getSize ();

      if (shl ||
	  (right = fold (new class BinopExpression
			  (BinopExpression::bMinus,
			   *new class Constant (*new class LeafValue
						(Net::getCardType (),
						 card_t (size))), *right)))) {
	if (right->getKind () == Expression::eConstant) {
	  const class Value& v =
	    static_cast<class Constant*>(right)->getValue ();
	  assert (v.getKind () == Value::vLeaf);
	  card_t amount = static_cast<const class LeafValue&>(v);
	  if (!(amount %= size)) {
	    right->destroy ();
	    return left;
	  }
	}
	return fold (new class VectorShift (*left, *right));
      }
    }
    left->destroy (), right->destroy ();
    return NULL;
  }

  left = ensureIntCard (left);
  right = ensureIntCard (right);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (!(right = left->getType ()->getKind () == Type::tCard
	? ensureCard (right) : ensureInt (right))) {
    left->destroy ();
    return NULL;
  }

  return fold (new class BinopExpression (op, *left, *right));
}

static class Expression*
newNotExpression (class Expression* expr)
{
  if ((expr = ensureBool (expr)))
    expr = fold (NotExpression::construct (*expr));
  return expr;
}

static class Expression*
newBooleanBinop (bool conj,
		 class Expression* left,
		 class Expression* right)
{
  assert (left && right);
  assert (left->getKind () == Expression::eUndefined ||
	  (left->getType () && left->getType ()->getKind () == Type::tBool));
  assert (right->getKind () == Expression::eUndefined ||
	  (right->getType () && right->getType ()->getKind () == Type::tBool));
  const class Value* v;
  bool value;
  assert (left == CSE (left));
  assert (right == CSE (right));

  if (left->getKind () == Expression::eConstant) {
    v = &static_cast<class Constant*>(left)->getValue ();
    left->destroy ();
    assert (v && v->getKind () == Value::vLeaf);
    value = bool (static_cast<const class LeafValue&>(*v));

    if (conj) {
      if (value)
	return right;
      else {
	right->destroy ();
      False:
	dewarn ("subexpression is always false");
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), false)));
      }
    }
    else {
      if (value) {
	right->destroy ();
      True:
	dewarn ("subexpression is always true");
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
      }
      else
	return right;
    }
  }
  else if (right->getKind () == Expression::eConstant) {
    v = &static_cast<class Constant*>(right)->getValue ();
    right->destroy ();
    assert (v && v->getKind () == Value::vLeaf);
    value = bool (static_cast<const class LeafValue&>(*v));

    if (conj) {
      if (value)
	return left;
      else {
	left->destroy ();
	goto False;
      }
    }
    else {
      if (value) {
	left->destroy ();
	goto True;
      }
      else
	return left;
    }
  }
  else
    return CSE (BooleanBinop::construct (conj, *left, *right));

  assert (false);
  return NULL;
}

static class Expression*
newSetExpression (enum SetExpression::Op op,
		  class Expression* left,
		  class Expression* right)
{
  const class Type* type = 0;
  if (right && right->isSet ())
    type = right->getType ();
  else if (left && left->isSet ())
    type = left->getType ();
  left = ensureSet (left, type);
  right = ensureSet (right, type);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (left->getKind () == Expression::eEmptySet) {
    if (right->getKind () == Expression::eEmptySet) {
    Same:
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
      case SetExpression::sUnion:
	right->destroy ();
	return left;
      case SetExpression::sSubset:
      case SetExpression::sEquals:
      True:
	left->destroy (), right->destroy ();
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
      }
      assert (false);
    }
    else {
      assert (!!right->getType ());
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
	right->destroy ();
	return left;
      case SetExpression::sUnion:
	left->destroy ();
	return right;
      case SetExpression::sSubset:
	goto True;
      case SetExpression::sEquals:
	goto Compatible;
      }
    }
  }
  else if (right->getKind () == Expression::eEmptySet) {
    switch (op) {
    case SetExpression::sIntersection:
      left->destroy ();
      return right;
    case SetExpression::sMinus:
    case SetExpression::sUnion:
      right->destroy ();
      return left;
    case SetExpression::sSubset:
      op = SetExpression::sEquals;
    case SetExpression::sEquals:
      { class Expression* e = left; left = right; right = e; }
      goto Compatible;
    }
  }

  if (left == right)
    goto Same;

  if (left->getType () == right->getType ()) {
  Compatible:
    return CSE (new class SetExpression (op, *left, *right));
  }
  else {
    deerror ("expressions have incompatible types");
    left->destroy (), right->destroy ();
    return NULL;
  }
}

static class Expression*
newCardinalityExpression (enum CardinalityExpression::Op op,
			  class Expression* expr)
{
  if (class Expression* m = ensureSet (expr)) {
    if (m->getKind () == Expression::eEmptySet) {
      m->destroy ();
      dewarn ("the cardinality of an empty set is always zero");
      return CSE (new class Constant (*new class LeafValue
				      (Net::getCardType (),
				       op == CardinalityExpression::cMin
				       ? CARD_T_MAX
				       : 0)));
    }
    else
      return CSE (new class CardinalityExpression (op, *m));
  }
  else
    return NULL;
}

static class Expression*
newBufferUnop (enum BufferUnop::Op op, class Expression* expr)
{
  if (!(expr = ensureBuffer (expr)))
    return NULL;

  if (expr->getKind () == Expression::eBufferIndex) {
    class BufferIndex* b = static_cast<class BufferIndex*>(expr);
    class Expression* buffer = &b->getBuffer ();
    class Expression* index = &b->getIndex ();
    b->destroy ();
    switch (op) {
    case BufferUnop::bFree:
    case BufferUnop::bUsed:
      if (index) {
	dewarn ("ignoring meaningless buffer indexing expression");
	index->destroy (), index = NULL;
      }
      break;
    case BufferUnop::bPeek:
      break;
    }

    return fold (new class BufferUnop (op, *buffer, index));
  }

  return fold (new class BufferUnop (op, *expr, NULL));
}
